var ClientCore, Share;

(function(e) {
e.CAsyncDelegate = class {
constructor() {
this.m_oDelegate = new e.CDelegate();
}
static isNullOrEmpty(e) {
return null == e || e.isEmpty();
}
isEmpty() {
return this.m_oDelegate.isEmpty();
}
clear() {
this.m_oDelegate.clear();
}
add(e, t) {
this.m_oDelegate.add(e, t);
}
remove(e) {
this.m_oDelegate.remove(e);
}
invoke(...e) {
return Promise.resolve().then(() => this.m_oDelegate.invoke(...e));
}
};
})(Share || (Share = {}));

(function(e) {
class t {
constructor() {
this.m_oObjRes = null;
this.m_oPrev = null;
this.m_oNext = null;
}
get Data() {
return this.m_oObjRes;
}
get Next() {
return this.m_oNext;
}
get Prev() {
return this.m_oPrev;
}
}
e.CObjResNode = t;
class r {
constructor() {
this.m_nIndex = 0;
this.m_nCheckNum = 1;
this.m_oData = new t();
}
}
e.CObjResMgr = class {
constructor(e, r, i) {
this.m_oObjRes = [];
this.m_oFreeIndex = [];
this.m_nSize = 0;
this.m_nSizeOfPool = 0;
this.m_oHead = new t();
this.m_oTail = new t();
this.m_nSizeOfPool = e < 0 ? 0 : e;
this.m_onObjConstructor = r;
this.m_onObjDestructor = i;
this.m_oHead.m_oNext = this.m_oTail;
this.m_oTail.m_oPrev = this.m_oHead;
}
begin() {
return this.m_oHead.Next;
}
end() {
return this.m_oTail;
}
rbegin() {
return this.m_oTail.Prev;
}
rend() {
return this.m_oHead;
}
getSize() {
return this.m_nSize;
}
createObj(t) {
let i = null;
t >= this.m_oFreeIndex.length && (this.m_oFreeIndex[t] = new e.CQueue());
null == this.m_oFreeIndex[t] && (this.m_oFreeIndex[t] = new e.CQueue());
let s = this.m_oFreeIndex[t];
if (s.isEmpty()) {
i = new r();
this.m_oObjRes.push(i);
i.m_nIndex = this.m_oObjRes.length - 1;
i.m_nCheckNum = 1;
} else {
let e = s.pop();
(i = this.m_oObjRes[e]).m_nIndex = e;
}
if (null == i.m_oData.m_oObjRes) {
let e = i.m_oData.m_oObjRes = this.m_onObjConstructor(t);
if (null == e || e.getObjType() != t) throw "object type error";
}
i.m_oUID = e.CObjResUIDHelper.toUID(i.m_nIndex, i.m_nCheckNum);
++this.m_nSize;
let o = i.m_oData.m_oObjRes;
i.m_oData.m_oPrev = this.m_oTail.Prev;
i.m_oData.m_oNext = this.m_oTail;
this.m_oTail.m_oPrev.m_oNext = i.m_oData;
this.m_oTail.m_oPrev = i.m_oData;
o.qconstructor(i.m_oUID);
return o;
}
getObj(e) {
let t = this._getObjRes(e);
return null == t ? null : t.m_oData.m_oObjRes;
}
releaseObj(e) {
let t = this._getObjRes(e);
this._releaseObj(t);
}
releaseAll() {
for (let e = 0; e != this.m_oObjRes.length; e++) {
let t = this.m_oObjRes[e];
this._releaseObj(t);
}
}
_getObjRes(t) {
let r = e.CObjResUIDHelper.toIndex(t), i = e.CObjResUIDHelper.toCheckNum(t);
if (0 == i) return null;
if (r >= this.m_oObjRes.length) return null;
let s = this.m_oObjRes[r];
return null == s || s.m_nCheckNum != i ? null : s;
}
_releaseObj(t) {
if (null == t || null == t.m_oData.m_oObjRes || e.CObjResUID.isNullOrZero(t.m_oUID)) return;
let r = t.m_oData.m_oObjRes, i = r.getObjType();
r.qdestructor();
--this.m_nSize;
let s = e.CObjResUIDHelper.toIndex(t.m_oUID);
t.m_oUID = e.CObjResUIDHelper.toUID(0, 0);
let o = this.m_oObjRes[s];
o.m_nCheckNum >= e.CObjResUIDHelper.getMaxCheckNum() ? o.m_nCheckNum = 1 : ++o.m_nCheckNum;
let n = t.m_oData.m_oPrev, a = t.m_oData.m_oNext;
n.m_oNext = a;
a.m_oPrev = n;
t.m_oData.m_oNext = null;
t.m_oData.m_oPrev = null;
this.m_nSize >= this.m_nSizeOfPool && (o.m_oData.m_oObjRes = null);
this.m_oFreeIndex[i].push(o.m_nIndex);
o.m_nIndex = this.m_oFreeIndex[i].getCount() - 1;
}
};
})(Share || (Share = {}));

(function(e) {
e.CUnit = class {
constructor(...e) {
this.m_oBehaviorList = [];
this.m_bIsDestroyed = !1;
this.m_oMsgReceiver = {};
if (null != e && 0 != e.length) for (let t = 0; t != e.length; ++t) if (void 0 === e[t].length) {
let r = e[t], i = r.c, s = new i(this, ...r.args);
s.__BehavId = i.BehaviorId;
s.__BehavLvl = t;
this[i.BehaviorId] = s;
this.m_oBehaviorList.push(s);
} else {
let r = e[t];
for (let e = 0; e != r.length; ++e) {
let i = r[e].c, s = new i(this, ...r[e].args);
s.__BehavId = i.BehaviorId;
s.__BehavLvl = t;
this[i.BehaviorId] = s;
this.m_oBehaviorList.push(s);
}
}
for (let e = 0; e != this.m_oBehaviorList.length; ++e) {
let t = this.m_oBehaviorList[e];
t._awake.call(t);
}
for (let e = 0; e != this.m_oBehaviorList.length; ++e) {
let t = this.m_oBehaviorList[e];
t._start.call(t);
}
}
isDestroyed() {
return this.m_bIsDestroyed;
}
getComponent(e) {
if (this.isDestroyed()) return null;
let t = this[e.BehaviorId];
return null == t ? null : t;
}
destroy() {
if (this.isDestroyed()) return;
this.m_bIsDestroyed = !0;
let e = this.m_oBehaviorList;
setTimeout(() => {
for (let t = e.length - 1; t >= 0; --t) e[t]._destroy.call(e[t]);
}, 0);
}
sendMsg(e, t, ...r) {
if (null == e) return;
let i = e.Unit.m_oMsgReceiver[t];
if (null == i) return;
let s = i[e.__BehavId];
null != s && Promise.resolve().then(() => {
s(this, r);
});
}
sendMsgToUnit(e, t, ...r) {
if (null == e) return;
let i = e.m_oMsgReceiver[t];
null != i && Promise.resolve().then(() => {
for (var e in i) {
let t = i[e];
null != t && t(this, r);
}
});
}
};
})(Share || (Share = {}));

(function(e) {
class t {
constructor(e) {
this.m_bIsDisabled = !1;
this.m_oOwner = e;
}
static get BehaviorId() {
if (null == this.s_nBehaviorId) {
t.maxBehaviorId || (t.maxBehaviorId = 0);
this.s_nBehaviorId = (++t.maxBehaviorId).toString();
}
return this.s_nBehaviorId;
}
get Unit() {
return this.m_oOwner;
}
_registerMsg(e, t) {
let r = this.m_oOwner.m_oMsgReceiver;
null == r[e] && (r[e] = {});
r[e][this.__BehavId] = t;
}
setDisable(e) {
if (this.m_bIsDisabled != e) {
this.m_bIsDisabled = e;
this.m_bIsDisabled ? setTimeout(() => {
this._disable();
}, 0) : setTimeout(() => {
this._enable();
}, 0);
}
}
getComponent(e) {
if (null == this.m_oOwner) return null;
let t = this.m_oOwner.getComponent(e);
if (null == t) return null;
if (t.__BehavLvl > this.__BehavLvl) throw new Error("Cannot get high level behavior");
return this.m_oOwner.getComponent(e);
}
destroy() {
this.m_oOwner.destroy();
}
isDestroyed() {
return this.m_oOwner.isDestroyed();
}
isDisabled() {
return this.isDestroyed() || this.m_bIsDisabled;
}
sendMsg(e, t, ...r) {
return this.m_oOwner.sendMsg(e, t, r);
}
sendMsgToUnit(e, t, ...r) {
return this.m_oOwner.sendMsgToUnit(e, t, r);
}
_awake() {}
_start() {}
_destroy() {}
_enable() {}
_disable() {}
}
e.CUnitBehavior = t;
})(Share || (Share = {}));

(function(e) {
e.CEffect = class {
get UID() {
return this.m_oUID;
}
qconstructor(e) {
this.m_oUID = e;
}
qdestructor() {
this.remove();
}
getObjType() {}
isRemoved() {
return this.m_bRemoved;
}
add(e, t) {
this._onAdd(e, t);
}
remove() {
if (!this.isRemoved) {
this.m_bRemoved = !0;
this._onRemove();
}
}
isAddForever() {
return this._isAddForever();
}
};
})(Share || (Share = {}));

(function(e) {
let t;
(function(e) {
e[e.Login = 1] = "Login";
e[e.Logout = 2] = "Logout";
e[e.Kickout = 3] = "Kickout";
e[e.ReLogin = 4] = "ReLogin";
e[e.EnterWorld = 5] = "EnterWorld";
e[e.LeaveWorld = 6] = "LeaveWorld";
e[e.CreatePlayer = 7] = "CreatePlayer";
e[e.Ping = 8] = "Ping";
e[e.FinishGuaJi = 9] = "FinishGuaJi";
e[e.SyncProperty = 10] = "SyncProperty";
e[e.UseBooster = 11] = "UseBooster";
e[e.Reborn = 12] = "Reborn";
e[e.UpgradeProperty = 13] = "UpgradeProperty";
e[e.Buy = 14] = "Buy";
e[e.SavePlayer = 15] = "SavePlayer";
e[e.ClaimOfflineReward = 16] = "ClaimOfflineReward";
e[e.ClaimInviteReward = 17] = "ClaimInviteReward";
e[e.GetInvitees = 18] = "GetInvitees";
e[e.Invite = 19] = "Invite";
e[e.StartRain = 20] = "StartRain";
e[e.QueryPlayer = 21] = "QueryPlayer";
e[e.GetInviteesByShareType = 22] = "GetInviteesByShareType";
e[e.OpenTractor = 23] = "OpenTractor";
e[e.GotoMarket = 24] = "GotoMarket";
e[e.SaveUserData = 25] = "SaveUserData";
e[e.GetRandomUser = 26] = "GetRandomUser";
e[e.FriendRequest = 27] = "FriendRequest";
e[e.AddFriend = 28] = "AddFriend";
e[e.QueryUserData = 29] = "QueryUserData";
e[e.IgnoreFriendRequest = 30] = "IgnoreFriendRequest";
e[e.DaLi = 31] = "DaLi";
e[e.DaoLuan = 32] = "DaoLuan";
e[e.Fire = 33] = "Fire";
e[e.WxLogin = 34] = "WxLogin";
e[e.GetAccessToken = 35] = "GetAccessToken";
e[e.GetWXACodeUnlimit = 36] = "GetWXACodeUnlimit";
e[e.ModifyMail = 37] = "ModifyMail";
e[e.GetTick = 38] = "GetTick";
})(t = e.EProtocolType || (e.EProtocolType = {}));
})(Share || (Share = {}));

(function(e) {
e.CProtocolMgr = class {
constructor() {
this.m_oControllers = [];
}
registerController(e, t) {
this.m_oControllers[t] = e;
}
getController(e) {
return this.m_oControllers[e];
}
};
})(Share || (Share = {}));

(function(e) {
e.CUnitClientSession = class extends Share.CUnit {
constructor(t) {
super([ Share.CUBC(e.CBehavSession, t), Share.CUBC(e.CBehavAccount), Share.CUBC(e.CBehavPlayerList), Share.CUBC(e.CBehavPlayer), Share.CUBC(e.CBehavWorldGate), Share.CUBC(Share.CBehavSceneCtrl), Share.CUBC(Share.CBehavEffect), Share.CUBC(Share.CBehavProperty), Share.CUBC(Share.CBehavPropertyCalc), Share.CUBC(e.CBehavReborn), Share.CUBC(e.CBehavUpgrade), Share.CUBC(e.CBehavShop), Share.CUBC(e.CBehavOffline), Share.CUBC(e.CBehavFriend), Share.CUBC(e.CBehavMail), Share.CUBC(e.CBehavClientSessionInterface) ]);
this.m_oInterface = this.getComponent(e.CBehavClientSessionInterface);
}
get BehavInterface() {
return this.m_oInterface;
}
};
})(ClientCore || (ClientCore = {}));

(function(e) {
e.COctStream = class {
constructor() {
this.m_oBuffer = new Uint8Array(16);
this.m_oDataView = new DataView(this.m_oBuffer.buffer);
this.m_nSize = 0;
this.m_nPopIndex = 0;
}
get Capacity() {
return null === this.m_oBuffer ? 0 : this.m_oBuffer.byteLength;
}
get Size() {
return this.m_nSize;
}
get Buffer() {
return this.m_oBuffer;
}
Assign(e, t, r) {
t || (t = 0);
r || (r = e ? e.length : 0);
if (0 != r) {
this.m_oBuffer = e.subarray(t, t + r);
this.m_oDataView = new DataView(this.m_oBuffer.buffer);
this.m_nSize = r;
this.m_nPopIndex = 0;
} else this.Clear();
}
Clear() {
this.m_nSize = 0;
this.m_nPopIndex = 0;
}
Reserve(e) {
if (e <= this.Capacity) return;
let t = new Uint8Array(e);
t.set(this.m_oBuffer);
this.m_oBuffer = t;
this.m_oDataView = new DataView(this.m_oBuffer.buffer);
}
Resize(e) {
let t = this.Capacity;
if (e <= t) this.m_nSize = e; else {
this.Reserve(2 * t > e ? 2 * t : e);
this.m_nSize = e;
}
}
pushUInt8(e) {
let t = this.m_nSize;
this.Resize(this.m_nSize + 1);
this.m_oDataView.setUint8(t, e);
return this;
}
pushInt8(e) {
let t = this.m_nSize;
this.Resize(this.m_nSize + 1);
this.m_oDataView.setInt8(t, e);
return this;
}
pushUInt16(e) {
let t = this.m_nSize;
this.Resize(this.m_nSize + 2);
this.m_oDataView.setUint16(t, e, !0);
return this;
}
pushInt16(e) {
let t = this.m_nSize;
this.Resize(this.m_nSize + 2);
this.m_oDataView.setInt16(t, e, !0);
return this;
}
pushUInt32(e) {
let t = this.m_nSize;
this.Resize(this.m_nSize + 4);
this.m_oDataView.setUint32(t, e, !0);
return this;
}
pushInt32(e) {
let t = this.m_nSize;
this.Resize(this.m_nSize + 4);
this.m_oDataView.setInt32(t, e, !0);
return this;
}
pushUInt64(e) {
let t = this.m_nSize;
this.Resize(this.m_nSize + 8);
this.m_oDataView.setUint32(t, e.getLowBits(), !0);
this.m_oDataView.setUint32(t + 4, e.getHighBits(), !0);
return this;
}
pushInt64(e) {
let t = this.m_nSize;
this.Resize(this.m_nSize + 8);
this.m_oDataView.setUint32(t, e.getLowBits(), !0);
this.m_oDataView.setUint32(t + 4, e.getHighBits(), !0);
return this;
}
pushFloat(e) {
let t = this.m_nSize;
this.Resize(this.m_nSize + 4);
this.m_oDataView.setFloat32(t, e, !0);
return this;
}
pushDouble(e) {
let t = this.m_nSize;
this.Resize(this.m_nSize + 8);
this.m_oDataView.setFloat64(t, e, !0);
return this;
}
pushString(t) {
let r = e.CUtf8Encoding.Encode(t), i = r.length, s = this.m_nSize;
this.Resize(this.m_nSize + 4 + r.length);
this.m_oDataView.setUint32(s, i, !0);
s += 4;
this.m_oBuffer.set(r, s);
return this;
}
pushData(e) {
e.marshal(this);
return this;
}
popUInt8() {
return this.m_oDataView.getUint8(this.m_nPopIndex++);
}
popInt8() {
return this.m_oDataView.getInt8(this.m_nPopIndex++);
}
popUInt16() {
let e = this.m_oDataView.getUint16(this.m_nPopIndex, !0);
this.m_nPopIndex += 2;
return e;
}
popInt16() {
let e = this.m_oDataView.getInt16(this.m_nPopIndex, !0);
this.m_nPopIndex += 2;
return e;
}
popUInt32() {
let e = this.m_oDataView.getUint32(this.m_nPopIndex, !0);
this.m_nPopIndex += 4;
return e;
}
popInt32() {
let e = this.m_oDataView.getInt32(this.m_nPopIndex, !0);
this.m_nPopIndex += 4;
return e;
}
popUInt64() {
let t = this.m_oDataView.getUint32(this.m_nPopIndex, !0);
this.m_nPopIndex += 4;
let r = this.m_oDataView.getUint32(this.m_nPopIndex, !0);
this.m_nPopIndex += 4;
return new e.CInt64(t, r);
}
popInt64() {
let t = this.m_oDataView.getUint32(this.m_nPopIndex, !0);
this.m_nPopIndex += 4;
let r = this.m_oDataView.getUint32(this.m_nPopIndex, !0);
this.m_nPopIndex += 4;
return new e.CInt64(t, r);
}
popFloat() {
let e = this.m_oDataView.getFloat32(this.m_nPopIndex, !0);
this.m_nPopIndex += 4;
return e;
}
popDouble() {
let e = this.m_oDataView.getFloat64(this.m_nPopIndex, !0);
this.m_nPopIndex += 8;
return e;
}
popString() {
let t = this.popUInt32(), r = e.CUtf8Encoding.Decode(this.m_oBuffer, this.m_nPopIndex, t);
this.m_nPopIndex += t;
return r;
}
popData(e) {
e.unMarshal(this);
}
toString() {
return 0 === this.Size ? "" : e.CUtf8Encoding.Decode(this.m_oBuffer, 0, this.Size);
}
};
})(Share || (Share = {}));

(function(e) {
e.CPromiseHelper = class {
static resolve(e) {
return Promise.resolve(e);
}
static reject(e) {
return Promise.reject(e);
}
static all(e) {
return Promise.all(e);
}
static race(e) {
return Promise.race(e);
}
static delay(e) {
let t, r = new Promise(function(e, r) {
t = function(t, i) {
null == t ? e(i) : r(t);
};
});
setTimeout(function() {
t(null, null);
}, e);
return r;
}
static createPromise() {
let e, t = new Promise(function(t, r) {
e = function(e, i) {
null == e ? t(i) : r(e);
};
});
return {
callback: e,
promise: t
};
}
static promisify(e, t) {
return function() {
for (var r, i = [], s = 0; s < arguments.length; s++) i.push(arguments[s]);
var o = new Promise(function(e, t) {
r = function(r, i) {
null == r ? e(i) : t(r);
};
});
e.apply(t || this, i.concat(r));
return o;
};
}
};
})(Share || (Share = {}));

(function(e) {
e.CQueue = class {
constructor() {
this.m_aList = [];
this.m_nBegin = 0;
this.m_nEnd = 0;
this.reserve(2);
}
reserve(e) {
let t = e + 1;
if (t <= this.m_aList.length) return;
let r = this.getCount(), i = [];
for (let e = this.m_nBegin; e != this.m_nEnd; e = (e + 1) % this.m_aList.length) {
let t = this.m_aList[e];
i.push(t);
}
i[t - 1] = null;
this.m_aList = i;
this.m_nBegin = 0;
this.m_nEnd = r;
}
at(e) {
if (!this.m_aList || e < 0 || e >= this.getCount()) throw "out of range";
return this.m_aList[(this.m_nBegin + e) % this.m_aList.length];
}
set(e, t) {
if (!this.m_aList || e < 0 || e >= this.getCount()) throw "out of range";
this.m_aList[(this.m_nBegin + e) % this.m_aList.length] = t;
}
clear() {
this.m_nEnd = this.m_nBegin = 0;
this.m_aList = [];
}
pop() {
let e = this.at(0);
this.m_aList[this.m_nBegin] = void 0;
this.m_nBegin = (this.m_nBegin + 1) % this.m_aList.length;
return e;
}
push(e) {
this.isFull() && this.reserve(2 * this.getCount());
this.m_aList[this.m_nEnd] = e;
this.m_nEnd = (this.m_nEnd + 1) % this.m_aList.length;
return e;
}
getCount() {
return this.m_nEnd < this.m_nBegin ? this.m_aList.length - this.m_nBegin + this.m_nEnd : this.m_nEnd - this.m_nBegin;
}
isEmpty() {
return this.m_nBegin == this.m_nEnd;
}
isFull() {
return (this.m_nEnd + 1) % this.m_aList.length == this.m_nBegin;
}
};
})(Share || (Share = {}));

(function(e) {
e.CSingleton = function(e) {
return e.__singleton$ ? e.__singleton$ : e.__singleton$ = new e();
};
})(Share || (Share = {}));

(function(e) {
const t = [ 100, 10100, 1010100, 101010100, 10101010100 ], r = t[0];
class i {
constructor() {
this.m_bDestroyed = !1;
}
get isDestroyed() {
return this.m_bDestroyed;
}
destroy() {
this.m_bDestroyed = !0;
}
}
e.CTimer = i;
class s {
constructor() {
this.m_nTimeScale = 1;
this.m_oTimers = [];
this.m_oExtTimers = [];
this.m_nCurTime = 0;
this.m_nDeltaTime = 0;
this.m_onFrameLoopFunc = (e => {
if (!(e <= 0 || this.m_nTimeScale <= 0)) {
this.m_nDeltaTime += e * this.m_nTimeScale;
for (;this.m_nDeltaTime >= e; ) {
this._execTimer();
this.m_nDeltaTime -= e;
this.m_nCurTime += e;
}
}
});
}
static create(e, t = 0) {
let r = this.m_oObjMgr.createObj(0);
r._init(e, t);
return r;
}
static release(e) {
e && this.m_oObjMgr.releaseObj(e.m_oUID);
}
static global() {
null == this.m_oGlobalTimerMgr && (this.m_oGlobalTimerMgr = s.create(e.CSingleton(e.CFrameLoopTimerImpl)));
return this.m_oGlobalTimerMgr;
}
get CurTime() {
return this.m_nCurTime;
}
get TimeScale() {
return this.m_nTimeScale;
}
set TimeScale(e) {
this.m_nTimeScale = e < 0 ? 0 : e;
}
_execTimer() {
if (0 === this.m_oTimers.length) return;
let e = this.m_oTimers[0];
if (null != e) for (;this.m_nCurTime >= e.endTime - r + e.offset; this._tick(0)) {
let t = e.execInfo[e.offset];
if (null != t) for (let e = 0; e != t.length; ++e) t[e].execFunc();
}
}
_tick(e) {
if (e >= this.m_oTimers.length) return;
e < 0 && (e = 0);
let i = this.m_oTimers[e];
i.execInfo[i.offset] && (i.execInfo[i.offset] = null);
let s = 0 === e ? t[e] : t[e] - t[e - 1], o = (t[e] - (0 === e ? 0 : t[e - 1])) / r | 0;
0 === e && i.offset >= i.execInfo.length && (this.m_nCurTime >= i.endTime ? i.offset = r - 1 : i.offset = (this.m_nCurTime + s - i.endTime) / o | 0);
i.offset++;
if (i.offset < r) return;
i.offset = 0;
i.endTime = i.endTime + s;
i.execInfo = [];
if (e === this.m_oTimers.length - 1) {
let e = this.m_oExtTimers.length, t = this.m_oExtTimers;
this.m_oExtTimers = [];
for (let r = 0; r != e; ++r) this._addTimerExecFunc(t[r].execTime, t[r].execFunc);
return;
}
let n = this.m_oTimers[e + 1], a = n.execInfo[n.offset];
this._tick(e + 1);
if (null == a) return;
let h = i.endTime - s;
for (let e = 0; e != a.length; ++e) {
let t = a[e], r = (t.execTime - h) / o | 0;
null == i.execInfo[r] && (i.execInfo[r] = []);
i.execInfo[r].push(t);
}
}
_init(e, r) {
let i = t.length;
this.m_oTimers = [];
for (let e = 0; e != i; ++e) this.m_oTimers.push({
endTime: r + t[e],
offset: 0,
execInfo: []
});
this.m_oExtTimers = [];
this.m_oFrameLoop = e;
this.m_oFrameLoop.onFrame.add(this.m_onFrameLoopFunc);
}
qconstructor(e) {
this.m_oUID = e;
}
qdestructor() {
this.m_oUID = null;
this.m_nCurTime = 0;
this.m_oTimers = [];
this.m_oExtTimers = [];
this.m_nTimeScale = 1;
if (this.m_oFrameLoop) {
this.m_oFrameLoop.onFrame.remove(this.m_onFrameLoopFunc);
this.m_oFrameLoop = null;
}
}
getObjType() {
return 0;
}
start(e, t, r = 0, s = e) {
let o = new i(), n = 0, a = this.m_nCurTime, h = () => {
if (!o.isDestroyed) {
t(n++, r);
(0 === r || n < r) && !o.isDestroyed ? this._addTimerExecFunc(a + s + e * n, h) : o.destroy();
}
};
this._addTimerExecFunc(a + s, h);
return o;
}
startOnce(e, t) {
return this.start(e, t, 1, e);
}
startForever(e, t, r = e) {
return this.start(e, t, 0, r);
}
stop(e) {
e.destroy();
}
_addTimerExecFunc(e, i) {
let s = !1;
for (let o = 0; o != this.m_oTimers.length; ++o) {
let n = this.m_oTimers[o];
if (e >= n.endTime) continue;
s = !0;
let a = (e - (n.endTime - (0 === o ? t[o] : t[o] - t[o - 1]))) / ((t[o] - (0 === o ? 0 : t[o - 1])) / r | 0) | 0;
null == n.execInfo[a] && (n.execInfo[a] = []);
n.execInfo[a].push({
execTime: e,
execFunc: i
});
break;
}
s || this.m_oExtTimers.push({
execTime: e,
execFunc: i
});
}
}
s.m_oObjMgr = new e.CObjResMgr(0, e => new s());
e.CTimerMgr = s;
})(Share || (Share = {}));

(function(e) {
e.CUBC = function(e, ...t) {
return {
c: e,
args: t
};
};
})(Share || (Share = {}));

(function(e) {
e.CDelegate = class {
constructor() {
this.m_oFuncList = new e.CLinkedList();
}
static isNullOrEmpty(e) {
return null == e || e.isEmpty();
}
isEmpty() {
return 0 == this.m_oFuncList.count();
}
clear() {
this.m_oFuncList.clear();
}
add(e, t) {
null != e && this.m_oFuncList.insertBefore(this.m_oFuncList.end(), {
func: e,
self: t
});
}
remove(e) {
if (null == e) return;
let t = this.m_oFuncList.end();
for (let r = this.m_oFuncList.begin(); r != t; r = r.getNext()) if (r.data.func === e) {
this.m_oFuncList.remove(r);
break;
}
}
invoke(...e) {
let t = this.m_oFuncList.end(), r = this, i = [];
(function() {
for (let s = r.m_oFuncList.begin(); s != t; ) {
let t = s.data;
s = s.getNext();
t.self ? i.push(t.func.apply(t.self, e)) : i.push(t.func.apply(this, e));
}
})();
return i;
}
};
})(Share || (Share = {}));

(function(e) {
let t;
(function(e) {
e[e.Fail = -1] = "Fail";
e[e.Success = 0] = "Success";
e[e.InvalidArguments = 1] = "InvalidArguments";
e[e.InvalidSQL = 2] = "InvalidSQL";
e[e.InvalidOperation = 3] = "InvalidOperation";
e[e.ConnectFailed = 4] = "ConnectFailed";
e[e.Timeout = 5] = "Timeout";
e[e.ServerOffline = 6] = "ServerOffline";
e[e.InvalidToken = 7] = "InvalidToken";
e[e.InvalidSession = 8] = "InvalidSession";
e[e.Logining = 9] = "Logining";
e[e.Logouting = 10] = "Logouting";
e[e.TryAgain = 11] = "TryAgain";
e[e.SessionClosed = 12] = "SessionClosed";
e[e.BehaviorDisabled = 13] = "BehaviorDisabled";
e[e.Connected = 14] = "Connected";
e[e.InvalidLevel = 15] = "InvalidLevel";
e[e.NoEnoughItem = 16] = "NoEnoughItem";
e[e.LowLevel = 17] = "LowLevel";
e[e.PrerequisitesAreNotMet = 18] = "PrerequisitesAreNotMet";
e[e.RepeatRequest = 19] = "RepeatRequest";
e[e.AlreadyFriend = 20] = "AlreadyFriend";
})(t = e.EErrorNo || (e.EErrorNo = {}));
e.CErrorMsgHelper = class {
constructor() {
this.errorMap = [];
this.errorMap[t.InvalidArguments] = "Invalid Arguments";
this.errorMap[t.InvalidSQL] = "Invalid SQL";
this.errorMap[t.InvalidOperation] = "Invalid Operation";
this.errorMap[t.ConnectFailed] = "Connect Failed";
this.errorMap[t.Timeout] = "Timeout";
this.errorMap[t.ServerOffline] = "ServerOffline";
this.errorMap[t.InvalidToken] = "InvalidToken";
this.errorMap[t.InvalidSession] = "InvalidSession";
this.errorMap[t.TryAgain] = "Try again";
this.errorMap[t.SessionClosed] = "Session Closed";
this.errorMap[t.BehaviorDisabled] = "Behavior Disabled";
this.errorMap[t.Connected] = "Connected";
this.errorMap[t.InvalidLevel] = "InvalidLevel";
this.errorMap[t.NoEnoughItem] = "No enough item";
this.errorMap[t.LowLevel] = "Low level";
this.errorMap[t.PrerequisitesAreNotMet] = "Prerequisites are not met";
}
createErrorMsg(e, t, r) {
var i = {
errno: e || 0,
errmsg: t || ""
};
null != r && (i.ext = r);
return i;
}
errorMsg(e, t) {
var r = {
errno: e || 0,
errmsg: this.errorMap[e] ? this.errorMap[e] : ""
};
null != t && (r.ext = t);
return r;
}
successMsg(e) {
var t = {
errno: 0,
errmsg: ""
};
null != e && (t.ext = e);
return t;
}
toErrorMsg(e) {
return null == e ? this.successMsg() : null == e.errno ? this.errorMsg(-1, e.toString()) : e;
}
};
})(Share || (Share = {}));

(function(e) {
class t {
static toUID(e, t) {
return new r(e, t);
}
static toIndex(e) {
return e.m_nIndex;
}
static toCheckNum(e) {
return e.m_nCheckNum;
}
static getMaxIndex() {
return (1 << t.s_nIndexLen) - 1;
}
static getMaxCheckNum() {
return (1 << t.s_nCheckNumLen) - 1;
}
}
t.s_nIndexLen = 30;
t.s_nCheckNumLen = 22;
e.CObjResUIDHelper = t;
class r {
constructor(e, t) {
this.m_nIndex = 0;
this.m_nCheckNum = 0;
this.m_nIndex = e;
this.m_nCheckNum = t;
}
static isNullOrZero(e) {
return null == e || e.isZero();
}
isZero() {
return 0 == this.m_nCheckNum && 0 == this.m_nIndex;
}
valueOf() {
return this.m_nIndex * (t.getMaxCheckNum() + 1) + this.m_nCheckNum;
}
toString() {
return this.valueOf().toString();
}
}
e.CObjResUID = r;
})(Share || (Share = {}));

(function(e) {
class t {
static _index(e, t) {
if (e < 0 || e >= t.length) throw new Error("IndexOutOfRangeException");
return e;
}
static _identity(e) {
return e;
}
static Encode(e) {
var r = null, i = 0, s = null != r, o = 0, n = function(e) {
for (var t = e.length, n = 0; n < t; n = n + 1 | 0) {
var a = e[this._index(n, e)];
if (s) {
if (i >= r.length) throw new Error("ArgumentException bytes");
r[this._index(this._identity(i, i = i + 1 | 0), r)] = a;
} else r.push(a);
o = o + 1 | 0;
}
};
s || (r = []);
for (var a = 0; a < e.length; a = a + 1 | 0) {
var h = e.charCodeAt(a);
if (h >= 55296 && h <= 56319) {
var l = e.charCodeAt(a + 1 | 0);
l >= 56320 && l <= 57343 || (h = t.fallbackCharacter);
} else h >= 56320 && h <= 57343 && (h = t.fallbackCharacter);
if (h < 128) n([ h ]); else if (h < 2048) n([ 192 | h >> 6, 128 | 63 & h ]); else if (h < 55296 || h >= 57344) n([ 224 | h >> 12, 128 | h >> 6 & 63, 128 | 63 & h ]); else {
a = a + 1 | 0;
var c = 65536 + ((1023 & h) << 10 | 1023 & e.charCodeAt(a)) | 0;
n([ 240 | c >> 18, 128 | c >> 12 & 63, 128 | c >> 6 & 63, 128 | 63 & c ]);
}
}
return s ? null : new Uint8Array(r);
}
static Decode(e, t, r) {
for (var i = t = null != t ? t : 0, s = "", o = 0, n = !1, a = i + (r = null != r ? r : e.byteLength) | 0; i < a; i = i + 1 | 0) {
var h = 0, l = 0, c = !1, m = e[this._index(i, e)];
if (m <= 127) h = m; else if (0 == (64 & m)) c = !0; else if (192 == (224 & m)) {
h = 31 & m;
l = 1;
} else if (224 == (240 & m)) {
h = 15 & m;
l = 2;
} else if (240 == (248 & m)) {
h = 7 & m;
l = 3;
} else if (248 == (252 & m)) {
h = 3 & m;
l = 4;
c = !0;
} else if (252 == (254 & m)) {
h = 3 & m;
l = 5;
c = !0;
} else {
h = m;
c = !1;
}
for (;l > 0; ) {
if ((i = i + 1 | 0) >= a) {
c = !0;
break;
}
var u = e[this._index(i, e)];
l = l - 1 | 0;
if (128 != (192 & u)) {
i = i - 1 | 0;
c = !0;
break;
}
h = h << 6 | 63 & u;
}
var g = null;
n = !1;
if (!c) if (o > 0 && !(h >= 56320 && h <= 57343)) {
c = !0;
o = 0;
} else if (h >= 55296 && h <= 56319) o = 65535 & h; else if (h >= 56320 && h <= 57343) {
c = !0;
n = !0;
o = 0;
} else {
g = h > 65535 ? (h -= 65536, String.fromCharCode(55296 + (h >> 10), 56320 + (1023 & h))) : String.fromCharCode(h);
o = 0;
}
if (c) {
if (this.throwOnInvalid) throw new Error("Invalid character in UTF8 text");
s = (s || "") + String.fromCharCode(this.fallbackCharacter);
} else 0 === o && (s = (s || "") + (g || ""));
}
if (o > 0 || n) {
if (this.throwOnInvalid) throw new Error("Invalid character in UTF8 text");
s = s.length > 0 && s.charCodeAt(s.length - 1 | 0) === this.fallbackCharacter ? (s || "") + String.fromCharCode(this.fallbackCharacter) : (s || "") + (this.fallbackCharacter + this.fallbackCharacter | 0);
}
return s;
}
}
t.fallbackCharacter = 65533;
e.CUtf8Encoding = t;
})(Share || (Share = {}));

(function(e) {
e.CAllClientTable = class {
constructor() {
this.m_oGlobalConfigMgr = new e.CGlobalConfigData();
this.m_oShareSwitchMgr = new e.CShareSwitchData();
this.m_oFramLandAttrMgr = new e.CFarmLandAttrMgrData();
this.m_oCropAttrMgr = new e.CCropAttrMgrData();
this.m_oUnitAttrMgr = new e.CUnitAttrMgrData();
this.m_oTechAttrMgr = new e.CTechAttrMgrData();
this.m_oInviteAttrMgr = new e.CInviteAttrMgrData();
this.m_oFarmSkinAttrMgr = new e.CFarmSkinAttrMgrData();
this.m_oFarmAttrMgr = new e.CFarmAttrMgrData();
this.m_oGemItemAttrMgr = new e.CGemItemAttrMgrData();
this.m_oUnlockAttrMgr = new e.CUnlockAttrMgrData();
this.m_oWheelAttrMgr = new e.CWheelAttrMgrData();
this.m_oSevenDaysAttrMgr = new e.CSevenDaysAttrMgrData();
this.m_oInviteClintAttrMgr = new e.CInviteClientAttrMgrData();
this.m_oAutoRewardAttrMgr = new e.CAutoRewardAttrMgrData();
this.m_oJobAttrMgr = new e.CJobAttrMgrData();
this.m_oFarmerAttrMgr = new e.CFarmerAttrMgrData();
this.m_oGuideTaskAttrMgr = new e.CGuideTaskAttrMgrData();
this.m_oDialogueAttrMgr = new e.CDialogueAttrMgrData();
this.m_oTreasureFirstAttrMgr = new e.CTreasureFirstAttrMgrData();
this.m_oTreasureSecondAttrMgr = new e.CTreasureSecondAttrMgrData();
this.m_oBubbleFirstAttrMgr = new e.CBubbleFirstAttrMgrData();
this.m_oBubbleSecondAttrMgr = new e.CBubbleSecondAttrMgrData();
this.m_oProvinceAttrMgr = new e.CProvinceAttrMgrData();
}
marshal(e) {
e.pushString(JSON.stringify(this));
}
unMarshal(e) {
let t = JSON.parse(e.popString());
for (let e in t) null != this[e] && (this[e] = t[e]);
}
};
})(Share || (Share = {}));

(function(e) {
e.CAutoRewardAttr = class {
constructor() {
this.id = 0;
this.rate = 0;
this.seed = 0;
this.specialcrop = 0;
this.gem = 0;
this.woodbox = 0;
this.goldbox = 0;
}
};
e.CAutoRewardAttrMgr = class {
constructor() {
this.m_oMgrData = null;
}
init(e) {
this.m_oMgrData = e;
}
get(e) {
return this.m_oMgrData.m_oData[e];
}
get data() {
return this.m_oMgrData.m_oData;
}
get list() {
return this.m_oMgrData.m_lData;
}
};
e.CAutoRewardAttrMgrData = class {
constructor() {
this.m_oData = {};
this.m_lData = [];
}
marshal(e) {
e.pushString(JSON.stringify(this));
}
unMarshal(e) {
let t = JSON.parse(e.popString());
for (let e in t) this[e] = t[e];
}
};
})(Share || (Share = {}));

(function(e) {
e.CBubbleFirstAttr = class {
constructor() {
this.id = 0;
this.name = "";
this.type = 0;
this.count = 0;
this.number = 0;
this.contribution = 0;
this.game = 0;
this.share = 0;
this.video = 0;
this.official = 0;
this.prop = 0;
this.itemId = 0;
}
};
e.CBubbleFirstAttrMgr = class {
constructor() {
this.m_oMgrData = null;
}
init(e) {
this.m_oMgrData = e;
}
get(e) {
return this.m_oMgrData.m_oData[e];
}
get data() {
return this.m_oMgrData.m_oData;
}
get list() {
return this.m_oMgrData.m_lData;
}
};
e.CBubbleFirstAttrMgrData = class {
constructor() {
this.m_oData = {};
this.m_lData = [];
}
marshal(e) {
e.pushString(JSON.stringify(this));
}
unMarshal(e) {
let t = JSON.parse(e.popString());
for (let e in t) this[e] = t[e];
}
};
})(Share || (Share = {}));

(function(e) {
e.CBubbleSecondAttr = class {
constructor() {
this.id = 0;
this.content = "";
this.type = 0;
this.prop = 0;
this.desc = "";
this.voice = "";
}
};
e.CBubbleSecondAttrMgr = class {
constructor() {
this.m_oMgrData = null;
}
init(e) {
this.m_oMgrData = e;
}
get(e) {
return this.m_oMgrData.m_oData[e];
}
get data() {
return this.m_oMgrData.m_oData;
}
get list() {
return this.m_oMgrData.m_lData;
}
};
e.CBubbleSecondAttrMgrData = class {
constructor() {
this.m_oData = {};
this.m_lData = [];
}
marshal(e) {
e.pushString(JSON.stringify(this));
}
unMarshal(e) {
let t = JSON.parse(e.popString());
for (let e in t) this[e] = t[e];
}
};
})(Share || (Share = {}));

(function(e) {
e.CCropAttr = class {
constructor() {
this.id = 0;
this.name = "";
this.lvupcost = 0;
this.lvcostunit = "";
this.producttime = 0;
this.halflv = 0;
this.baseproduct = 0;
this.prounit = "";
this.farmlandid = 0;
this.itembg = "";
this.spine = "";
this.unlocklv = 0;
this.share = 0;
this.percent = 0;
this.tips = "";
this.enable = 0;
this.probability = 0;
this.type = 0;
this.harvest = "";
this.cash = 0;
this.ordercrop = 0;
this.orderneed = "";
this.gem = 0;
this.from = "";
this.proname = "";
this.videocrop = 0;
this.officer = 0;
}
};
e.CCropAttrMgr = class {
constructor() {
this.m_oMgrData = null;
}
init(e) {
this.m_oMgrData = e;
}
get(e) {
return this.m_oMgrData.m_oCrops[e];
}
get data() {
return this.m_oMgrData.m_oCrops;
}
get list() {
return this.m_oMgrData.m_aCrops;
}
};
e.CCropAttrMgrData = class {
constructor() {
this.m_oCrops = {};
this.m_aCrops = [];
}
marshal(e) {
e.pushString(JSON.stringify(this));
}
unMarshal(e) {
let t = JSON.parse(e.popString());
for (let e in t) this[e] = t[e];
}
};
})(Share || (Share = {}));

(function(e) {
e.CDialogueAttr = class {
constructor() {
this.id = 0;
this.dialogue = "";
this.audio = "";
this.position_x = 0;
this.position_y = 0;
}
};
e.CDialogueAttrMgr = class {
constructor() {
this.m_oMgrData = null;
}
init(e) {
this.m_oMgrData = e;
}
get(e) {
return this.m_oMgrData.m_oData[e];
}
get data() {
return this.m_oMgrData.m_oData;
}
get list() {
return this.m_oMgrData.m_lData;
}
};
e.CDialogueAttrMgrData = class {
constructor() {
this.m_oData = {};
this.m_lData = [];
}
marshal(e) {
e.pushString(JSON.stringify(this));
}
unMarshal(e) {
let t = JSON.parse(e.popString());
for (let e in t) this[e] = t[e];
}
};
})(Share || (Share = {}));

(function(e) {
e.CFarmAttr = class {
constructor() {
this.id = 0;
this.skinadd = 0;
this.needgold = 0;
this.needgoldunit = "";
this.tractortimes = 0;
this.seedlimit = 0;
this.seedlimitunit = "";
this.openfarm = 0;
this.openfarmunit = "";
this.skinname = "";
this.skindes = "";
this.job = "";
this.level = "";
this.quality = 0;
this.pond = 0;
this.icon = 0;
}
};
e.CFarmAttrMgrData = class {
constructor() {
this.m_oData = {};
this.m_lData = [];
}
marshal(e) {
e.pushString(JSON.stringify(this));
}
unMarshal(e) {
let t = JSON.parse(e.popString());
for (let e in t) this[e] = t[e];
}
};
e.CFarmAttrMgr = class {
constructor() {
this.m_oMgrData = null;
}
init(e) {
this.m_oMgrData = e;
}
get(e) {
return this.m_oMgrData.m_oData[e];
}
get data() {
return this.m_oMgrData.m_oData;
}
get list() {
return this.m_oMgrData.m_lData;
}
};
})(Share || (Share = {}));

(function(e) {
e.CFarmerAttr = class {
constructor() {
this.id = 0;
this.workstate = "";
this.effect = 0;
this.worktime = 0;
this.rate = 0;
this.farmerX = 0;
this.price = 0;
}
};
e.CFarmerAttrMgrData = class {
constructor() {
this.m_oData = {};
this.m_lData = [];
}
marshal(e) {
e.pushString(JSON.stringify(this));
}
unMarshal(e) {
let t = JSON.parse(e.popString());
for (let e in t) this[e] = t[e];
}
};
e.CFarmerAttrMgr = class {
constructor() {
this.m_oMgrData = null;
}
init(e) {
this.m_oMgrData = e;
}
get(e) {
return this.m_oMgrData.m_oData[e];
}
get data() {
return this.m_oMgrData.m_oData;
}
get list() {
return this.m_oMgrData.m_lData;
}
};
})(Share || (Share = {}));

(function(e) {
e.CFarmLandAttr = class {
constructor() {
this.id = 0;
this.crops = [];
this.landcostunit = "";
this.landunlockcost = 0;
}
};
e.CFarmLandAttrMgrData = class {
constructor() {
this.m_oFarmLands = {};
this.m_lData = [];
}
marshal(e) {
e.pushString(JSON.stringify(this));
}
unMarshal(e) {
let t = JSON.parse(e.popString());
for (let e in t) this[e] = t[e];
}
};
e.CFarmLandAttrMgr = class {
constructor() {
this.m_oMgrData = null;
}
init(e) {
this.m_oMgrData = e;
}
get(e) {
return this.m_oMgrData.m_oFarmLands[e];
}
get data() {
return this.m_oMgrData.m_oFarmLands;
}
get list() {
return this.m_oMgrData.m_lData;
}
};
})(Share || (Share = {}));

(function(e) {
e.CFarmSkinAttr = class {
constructor() {
this.id = 0;
this.skinadd = 0;
this.skinname = "";
this.skindes = "";
this.price = 0;
this.times = 0;
this.onshow = 0;
}
};
e.CFarmSkinAttrMgrData = class {
constructor() {
this.m_oData = {};
this.m_lData = [];
}
marshal(e) {
e.pushString(JSON.stringify(this));
}
unMarshal(e) {
let t = JSON.parse(e.popString());
for (let e in t) this[e] = t[e];
}
};
e.CFarmSkinAttrMgr = class {
constructor() {
this.m_oMgrData = null;
}
init(e) {
this.m_oMgrData = e;
}
get(e) {
return this.m_oMgrData.m_oData[e];
}
get data() {
return this.m_oMgrData.m_oData;
}
get list() {
return this.m_oMgrData.m_lData;
}
};
})(Share || (Share = {}));

(function(e) {
e.CGemItemAttr = class {
constructor() {
this.id = 0;
this.itemname = "";
this.effect = 0;
this.des = "";
this.gemcost = 0;
this.limit = 0;
}
};
e.CGemItemAttrMgrData = class {
constructor() {
this.m_oData = {};
this.m_lData = [];
}
marshal(e) {
e.pushString(JSON.stringify(this));
}
unMarshal(e) {
let t = JSON.parse(e.popString());
for (let e in t) this[e] = t[e];
}
};
e.CGemItemAttrMgr = class {
constructor() {
this.m_oMgrData = null;
}
init(e) {
this.m_oMgrData = e;
}
get(e) {
return this.m_oMgrData.m_oData[e];
}
get data() {
return this.m_oMgrData.m_oData;
}
get list() {
return this.m_oMgrData.m_lData;
}
};
})(Share || (Share = {}));

(function(e) {
class t {
constructor() {
this.appid = "";
this.secret = "";
this.heartlimit = 0;
this.ShareRandom = 0;
this.notice = "";
this.initialgem = 0;
this.initialgold = 0;
this.initialseed = 0;
this.seedprofit = 0;
this.invitecloudtime = 0;
this.farmertime = 0;
this.initialcloudtime = 0;
this.farmercontinue = 0;
this.gopherInterval = 0;
this.newrewardtype = 0;
this.newbeereward = "0";
this.tractorinvite = 0;
this.sliverbox = 0;
this.goldbox = 0;
this.sliverboxnum = 0;
this.goldboxnum = 0;
this.woodbox = 0;
this.tractortimenew = "0";
this.woodboxrate = "0";
this.gopherreward = 0;
this.gophertime = 0;
this.sliverboxCD = 0;
this.goldboxCD = 0;
this.cropunlocknum = 0;
this.coppernum = 0;
this.slivernum = 0;
this.goldnum = 0;
this.firstgold = 0;
this.copperproduct = 0;
this.sliverproduct = 0;
this.goldproduct = 0;
this.purchasegift1 = 0;
this.purchasegift2 = 0;
this.purchasegift3 = 0;
this.mooncard1gem = 0;
this.mooncard2gem = 0;
this.mooncard1box = 0;
this.mooncard2box = 0;
this.redpocket = 0;
this.newredpocket = 0;
this.bigredpocket = 0;
this.sharefriend = 0;
this.sharefriendbig = "0";
this.sharefriendcrop = 0;
this.timedgift1invite = 0;
this.timedgift2invite = 0;
this.timedgift3invite = 0;
this.timedgifttrigger = 0;
this.timedgift1reward = "0";
this.timedgift2reward = "0";
this.timedgift3reward1 = "0";
this.timedgift3reward2 = "0";
this.goldshare = "0";
this.goldsharetimes = 0;
this.goldshareover = 0;
this.npcfarmland = "0";
this.npcfarmlandlv = 0;
this.freegemsperday = 0;
this.freegemsdays = 0;
this.freegemstimes = 0;
this.noticetime = 0;
this.treasuremaptrigger = 0;
this.treasuremaprand = "0";
this.treasuremapsbox = "0";
this.treasuremaplbox = "0";
this.treasuremapclick1 = 0;
this.treasuremapclick2 = 0;
this.treasurecropid = 0;
this.publicaccountgems = 0;
this.stealgold = "0";
this.maketroublegold = "0";
this.tendlimit = 0;
this.friendlimit = 0;
this.energygift = 0;
this.energybiggift = 0;
this.newplayerenergy = 0;
this.energylimit = 0;
this.energyrecovery = 0;
this.maketroublefriend = 0;
this.maketroubleenemy = 0;
this.helpgold = "0";
this.treasuremaptime = 0;
this.redheart = 0;
this.blackheart = 0;
this.gohpergemlimit = 0;
this.energyfastcost = 0;
this.jobclickreward = 0;
this.sharegold = 0;
this.sharegoldtimes = 0;
this.newbuildlv = 0;
this.sharegoldmin = 0;
this.sharegoldclose = 0;
this.balloonclick = 0;
this.appinfo = "";
this.balloontime = 0;
this.farmerlimit = 0;
this.jobclicktime = 0;
this.wheelpiece = 0;
this.moblieappid = "";
this.mobliename = "";
this.hirefriendtimes = 0;
this.friendjob = 0;
this.tractorCDgem = 0;
this.balloonmiss = 0;
this.platinumnum = 0;
this.platinumproduct = 0;
this.platinumunlock = 0;
this.goldA = 0;
this.goldB = 0;
this.goldC = 0;
this.goldD = 0;
this.platinumA = 0;
this.platinumB = 0;
this.platinumC = 0;
this.platinumD = 0;
this.timedgiftskin = 0;
this.clearSize = 0;
this.orderrandom = 0;
this.orderCD = 0;
this.claimlimit = 0;
this.claimclicktime = 0;
this.callbackreward = "";
this.callbacktime = 0;
this.activeplayerreward = "";
this.backreward = "";
this.guoyuanappid = "";
this.IOSshare = "";
this.ANDshare = "";
this.sharetimea = 0;
this.IOSsharedaily2 = "";
this.ANDsharedaily2 = "";
this.orderCDclear = 0;
this.harvesttime = 0;
this.gemsharevideo = 0;
this.gemsharedata1 = "";
this.gemsharedata2 = "";
this.gemsharedata2config = "";
this.gemsharedata1configday1 = "";
this.gemsharedata1configday2 = "";
this.gemshareCD = 0;
this.gemsharevideolimit = 0;
this.yunvideolimit = 0;
this.autorewardrate = 0;
this.autorewardcd = 0;
this.autorewardlimit = 0;
this.bubbleshowCD = 0;
this.bubbleduring = 0;
this.bubblefirstduring = 0;
this.totalvideolimit = 0;
this.shareaward = "";
this.shareawardlimit = 0;
}
}
e.CGlobalConfigAttr = t;
e.CGlobalConfigData = class {
constructor() {
this.m_oAttr = new t();
}
marshal(e) {
e.pushString(JSON.stringify(this));
}
unMarshal(e) {
let t = JSON.parse(e.popString());
for (let e in t) this[e] = t[e];
}
};
e.CGlobalConfigMgr = class {
constructor() {
this.m_oMgrData = null;
}
get Data() {
return this.m_oMgrData.m_oAttr;
}
init(e) {
this.m_oMgrData = e;
}
};
})(Share || (Share = {}));

(function(e) {
e.CGuideTaskAttr = class {
constructor() {
this.id = 0;
this.taskdes = "";
this.data = 0;
}
};
e.CGuideTaskAttrMgr = class {
constructor() {
this.m_oMgrData = null;
}
init(e) {
this.m_oMgrData = e;
}
get(e) {
return this.m_oMgrData.m_oData[e];
}
get data() {
return this.m_oMgrData.m_oData;
}
get list() {
return this.m_oMgrData.m_lData;
}
};
e.CGuideTaskAttrMgrData = class {
constructor() {
this.m_oData = {};
this.m_lData = [];
}
marshal(e) {
e.pushString(JSON.stringify(this));
}
unMarshal(e) {
let t = JSON.parse(e.popString());
for (let e in t) this[e] = t[e];
}
};
})(Share || (Share = {}));

(function(e) {
e.CInviteAttr = class {
constructor() {
this.id = 0;
this.Count = 0;
this.AddPropertyID = [];
this.AddValue = [];
this.Title = "";
this.Desc = "";
}
};
e.CInviteAttrMgrData = class {
constructor() {
this.m_oAttrs = {};
this.length = 0;
}
marshal(e) {
e.pushString(JSON.stringify(this));
}
unMarshal(e) {
let t = JSON.parse(e.popString());
for (let e in t) this[e] = t[e];
}
};
e.CInviteAttrMgr = class {
constructor() {
this.m_oMgrData = null;
}
init(e) {
this.m_oMgrData = e;
}
getAllInviteAttrs() {
return this.m_oMgrData.m_oAttrs;
}
getInviteAttr(e) {
return this.m_oMgrData.m_oAttrs[e];
}
};
})(Share || (Share = {}));

(function(e) {
e.CInviteClientAttr = class {
constructor() {
this.id = 0;
this.invite = 0;
this.gem = 0;
this.radish = 0;
}
};
e.CInviteClientAttrMgr = class {
constructor() {
this.m_oMgrData = null;
}
init(e) {
this.m_oMgrData = e;
}
get(e) {
return this.m_oMgrData.m_oData[e];
}
get data() {
return this.m_oMgrData.m_oData;
}
get list() {
return this.m_oMgrData.m_lData;
}
};
e.CInviteClientAttrMgrData = class {
constructor() {
this.m_oData = {};
this.m_lData = [];
}
marshal(e) {
e.pushString(JSON.stringify(this));
}
unMarshal(e) {
let t = JSON.parse(e.popString());
for (let e in t) this[e] = t[e];
}
};
})(Share || (Share = {}));

(function(e) {
e.CJobAttr = class {
constructor() {
this.id = 0;
this.jobname = "";
this.jobdes = "";
this.jobnum = 0;
}
};
e.CJobAttrMgr = class {
constructor() {
this.m_oMgrData = null;
}
init(e) {
this.m_oMgrData = e;
}
get(e) {
return this.m_oMgrData.m_oData[e];
}
get data() {
return this.m_oMgrData.m_oData;
}
get list() {
return this.m_oMgrData.m_lData;
}
};
e.CJobAttrMgrData = class {
constructor() {
this.m_oData = {};
this.m_lData = [];
}
marshal(e) {
e.pushString(JSON.stringify(this));
}
unMarshal(e) {
let t = JSON.parse(e.popString());
for (let e in t) this[e] = t[e];
}
};
})(Share || (Share = {}));

(function(e) {
e.CProvinceAttr = class {
constructor() {
this.id = 0;
this.province = "";
this.label = "";
}
};
e.CProvinceAttrMgr = class {
constructor() {
this.m_oMgrData = null;
}
init(e) {
this.m_oMgrData = e;
}
get(e) {
return this.m_oMgrData.m_oData[e];
}
get data() {
return this.m_oMgrData.m_oData;
}
get list() {
return this.m_oMgrData.m_lData;
}
};
e.CProvinceAttrMgrData = class {
constructor() {
this.m_oData = {};
this.m_lData = [];
}
marshal(e) {
e.pushString(JSON.stringify(this));
}
unMarshal(e) {
let t = JSON.parse(e.popString());
for (let e in t) this[e] = t[e];
}
};
})(Share || (Share = {}));

(function(e) {
e.CSevenDaysAttr = class {
constructor() {
this.id = 0;
this.gem = 0;
this.goldhour = 0;
this.woodbox = 0;
this.goldbox = 0;
}
};
e.CSevenDaysAttrMgr = class {
constructor() {
this.m_oMgrData = null;
}
init(e) {
this.m_oMgrData = e;
}
get(e) {
return this.m_oMgrData.m_oData[e];
}
get data() {
return this.m_oMgrData.m_oData;
}
get list() {
return this.m_oMgrData.m_lData;
}
};
e.CSevenDaysAttrMgrData = class {
constructor() {
this.m_oData = {};
this.m_lData = [];
}
marshal(e) {
e.pushString(JSON.stringify(this));
}
unMarshal(e) {
let t = JSON.parse(e.popString());
for (let e in t) this[e] = t[e];
}
};
})(Share || (Share = {}));

(function(e) {
class t {
constructor() {
this.SHARE_FRIENDS = !0;
this.SHARE_PROMOTION = !0;
this.SHARE_ORDER = !0;
this.SEVEN_LOGIN = !0;
this.DIAMOND_REDPACK = !0;
this.SHARE_OFF_LINE = !0;
this.SHARE_OLD_MAN = !0;
this.NEWPLAYER_GUIDE = !0;
this.FUNCTION_GUIDE = !0;
this.LIMIT_GIFT = !0;
this.NOVICE_SHARE = !0;
this.NOVICE_SHARE_SWITCH = !0;
this.NOVICE_GEM = !0;
this.NOVICE_GEM_SWITCH = !0;
this.TREASURE_SWITCH = !0;
this.MAIL_SWITCH = !0;
this.GIFT_CODE_SWITCH = !0;
this.SOCIAL_SWITCH = !0;
this.TURNTABLE_SWITCH = !0;
this.FOLLOW_REWARD_SWITCH = !0;
this.ENERGY_SWITCH = !0;
this.SHARE_SWITCH = !0;
this.SCENE_MOVE = !0;
this.EMPOLYEE_SWITCH = !0;
this.zhishengFX = !0;
this.queqianFX = !0;
this.BALLOON = !0;
this.EXCHANGE = !0;
this.PRIVATE_CHAT = !0;
this.SHARE_FORBID = !1;
this.COMMIT_FILE_SIZE = !0;
this.CLEAR_CACHE = !0;
this.OLD_USER_REGRESS = !0;
this.GARDEN_SWITCH = !0;
this.Mondayshare = !0;
this.BOX_VIDEO = !0;
}
}
e.CShareSwitchAttr = t;
e.CShareSwitchData = class {
constructor() {
this.m_oAttr = new t();
}
marshal(e) {
e.pushString(JSON.stringify(this));
}
unMarshal(e) {
let t = JSON.parse(e.popString());
for (let e in t) this[e] = !!t[e];
}
};
e.CShareSwitchMgr = class {
constructor() {
this.m_oMgrData = null;
}
get Data() {
return this.m_oMgrData.m_oAttr;
}
init(e) {
this.m_oMgrData = e;
}
};
})(Share || (Share = {}));

(function(e) {
e.CTechAttr = class {
constructor() {
this.id = 0;
this.type = 0;
this.icon = 0;
this.name = "";
this.level = "";
this.des = "";
this.effect = 0;
this.effecttype = 0;
this.costtype = 0;
this.techcost = 0;
this.techcostunit = "";
this.landunlock = 0;
this.nexttech = 0;
this.farmlandid = 0;
this.lasttech = 0;
}
};
e.CTechAttrMgrData = class {
constructor() {
this.m_oData = {};
this.m_lData = [];
}
marshal(e) {
e.pushString(JSON.stringify(this));
}
unMarshal(e) {
let t = JSON.parse(e.popString());
for (let e in t) this[e] = t[e];
}
};
e.CTechAttrMgr = class {
constructor() {
this.m_oMgrData = null;
}
init(e) {
this.m_oMgrData = e;
}
get(e) {
return this.m_oMgrData.m_oData[e];
}
get data() {
return this.m_oMgrData.m_oData;
}
get list() {
return this.m_oMgrData.m_lData;
}
};
})(Share || (Share = {}));

(function(e) {
e.CTreasureFirstAttr = class {
constructor() {
this.id = 0;
this.min = 0;
this.max = 0;
this.one = 0;
this.two = 0;
this.three = 0;
this.four = 0;
this.five = 0;
}
};
e.CTreasureFirstAttrMgr = class {
constructor() {
this.m_oMgrData = null;
}
init(e) {
this.m_oMgrData = e;
}
get(e) {
return this.m_oMgrData.m_oData[e];
}
get data() {
return this.m_oMgrData.m_oData;
}
get list() {
return this.m_oMgrData.m_lData;
}
};
e.CTreasureFirstAttrMgrData = class {
constructor() {
this.m_oData = {};
this.m_lData = [];
}
marshal(e) {
e.pushString(JSON.stringify(this));
}
unMarshal(e) {
let t = JSON.parse(e.popString());
for (let e in t) this[e] = t[e];
}
};
})(Share || (Share = {}));

(function(e) {
e.CTreasureSecondAttr = class {
constructor() {
this.id = 0;
this.storeroom = 0;
this.goodsId = 0;
this.num = 0;
this.weight = 0;
}
};
e.CTreasureSecondAttrMgr = class {
constructor() {
this.m_oMgrData = null;
}
init(e) {
this.m_oMgrData = e;
}
get(e) {
return this.m_oMgrData.m_oData[e];
}
get data() {
return this.m_oMgrData.m_oData;
}
get list() {
return this.m_oMgrData.m_lData;
}
};
e.CTreasureSecondAttrMgrData = class {
constructor() {
this.m_oData = {};
this.m_lData = [];
}
marshal(e) {
e.pushString(JSON.stringify(this));
}
unMarshal(e) {
let t = JSON.parse(e.popString());
for (let e in t) this[e] = t[e];
}
};
})(Share || (Share = {}));

(function(e) {
e.CUnitAttr = class {
constructor() {
this.id = 0;
this.name = "";
this.nameunit = "";
this.percent = [];
this.unit = "";
}
};
e.CUnitAttrMgrData = class {
constructor() {
this.m_oData = {};
this.m_lData = [];
}
marshal(e) {
e.pushString(JSON.stringify(this));
}
unMarshal(e) {
let t = JSON.parse(e.popString());
for (let e in t) this[e] = t[e];
}
};
e.CUnitAttrMgr = class {
constructor() {
this.m_oMgrData = null;
}
init(e) {
this.m_oMgrData = e;
}
get(e) {
return this.m_oMgrData.m_oData[e];
}
get data() {
return this.m_oMgrData.m_oData;
}
get list() {
return this.m_oMgrData.m_lData;
}
};
})(Share || (Share = {}));

(function(e) {
e.CUnlockAttr = class {
constructor() {
this.id = 0;
this.tips = "";
this.farmland = 0;
this.lvcostunit = "";
this.harvesttimes = 0;
this.movetimes = 0;
this.close = 0;
}
};
e.CUnlockAttrMgr = class {
constructor() {
this.m_oMgrData = null;
}
init(e) {
this.m_oMgrData = e;
}
get(e) {
return this.m_oMgrData.m_oData[e];
}
get data() {
return this.m_oMgrData.m_oData;
}
get list() {
return this.m_oMgrData.m_lData;
}
};
e.CUnlockAttrMgrData = class {
constructor() {
this.m_oData = {};
this.m_lData = [];
}
marshal(e) {
e.pushString(JSON.stringify(this));
}
unMarshal(e) {
let t = JSON.parse(e.popString());
for (let e in t) this[e] = t[e];
}
};
})(Share || (Share = {}));

(function(e) {
e.CWheelAttr = class {
constructor() {
this.id = 0;
this.prob = 0;
this.type = 0;
this.data = 0;
}
};
e.CWheelAttrMgr = class {
constructor() {
this.m_oMgrData = null;
}
init(e) {
this.m_oMgrData = e;
}
get(e) {
return this.m_oMgrData.m_oData[e];
}
get data() {
return this.m_oMgrData.m_oData;
}
get list() {
return this.m_oMgrData.m_lData;
}
};
e.CWheelAttrMgrData = class {
constructor() {
this.m_oData = {};
this.m_lData = [];
}
marshal(e) {
e.pushString(JSON.stringify(this));
}
unMarshal(e) {
let t = JSON.parse(e.popString());
for (let e in t) this[e] = t[e];
}
};
})(Share || (Share = {}));

(function(e) {
e.CBattleSceneFrameLoop = class {
constructor(t = 10) {
this.onFrame = new e.CDelegate();
this.m_oBaseTimerMgr = e.CTimerMgr.global();
this.m_nIntervalMilliSeconds = t;
this._frameLoop();
}
_frameLoop() {
this.m_oTimer = this.m_oBaseTimerMgr.startForever(this.m_nIntervalMilliSeconds, () => {
this.onFrame.invoke(this.m_nIntervalMilliSeconds);
});
}
stop() {
if (this.m_oTimer) {
this.m_oTimer.destroy();
this.m_oTimer = null;
}
}
};
})(Share || (Share = {}));

(function(e) {
class t extends e.CUnitBehavior {
constructor(e) {
super(e);
}
_awake() {
if (null == t.m_aEffectConstructors) {
t.m_aEffectConstructors = [];
t.m_aEffectConstructors[e.EEffectType.AddProperty] = e.CEffectAddProperty;
}
this.m_oEffectMgr = new e.CObjResMgr(0, e => {
let r = t.m_aEffectConstructors[e];
return null == r ? null : new r();
});
}
add(e, t) {
let r = this.m_oEffectMgr.createObj(e);
if (null == r) return null;
r.add(this, t);
r.isAddForever() && this.m_oEffectMgr.releaseObj(r.UID);
return r.UID;
}
remove(e) {
this.m_oEffectMgr.releaseObj(e);
}
}
e.CBehavEffect = t;
})(Share || (Share = {}));

(function(e) {
e.CBehavProperty = class extends e.CUnitBehavior {
constructor(t) {
super(t);
this.m_onPropertyChanged = new e.CAsyncDelegate();
this.m_onPropertyRegistered = new e.CAsyncDelegate();
this.m_aPropertyContainers = [];
}
get OnPropertyChanged() {
return this.m_onPropertyChanged;
}
get OnPropertyRegistered() {
return this.m_onPropertyRegistered;
}
register(e, t) {
this.m_aPropertyContainers[e] = t;
this.m_onPropertyRegistered.invoke(e, t);
}
add(e, t, r) {
if (null == this.m_aPropertyContainers[e]) return;
let i = this.m_aPropertyContainers[e];
i[t] || (i[t] = 0);
let s = i[t];
i[t] += r;
let o = i[t];
s !== o && setTimeout(() => {
this.m_onPropertyChanged.invoke(e, t, s, o);
}, 0);
}
set(e, t, r) {
if (null == this.m_aPropertyContainers[e]) return;
let i = this.m_aPropertyContainers[e], s = i[t];
s || (s = 0);
i[t] = r;
let o = i[t];
s !== o && setTimeout(() => {
this.m_onPropertyChanged.invoke(e, t, s, o);
}, 0);
}
get(e, t) {
if (null == this.m_aPropertyContainers[e]) return;
let r = this.m_aPropertyContainers[e];
return r[t] ? r[t] : null;
}
};
})(Share || (Share = {}));

(function(e) {
e.CBehavPropertyCalc = class extends e.CUnitBehavior {
constructor(e) {
super(e);
}
_awake() {
this.m_oBehavProperty = this.getComponent(e.CBehavProperty);
}
getOfflineCoinPerSecond() {
let t = this.m_oBehavProperty.get(e.EPropertyContainerType.Property, e.EPropertyType[e.EPropertyType.Level]);
return 20 * Math.pow(2, t - 1);
}
};
})(Share || (Share = {}));

(function(e) {
e.CBehavScene = class extends e.CUnitBehavior {
constructor(t) {
super(t);
this.m_onEnter = new e.CDelegate();
this.m_onLeave = new e.CDelegate();
this.m_nID = 0;
this.m_oSceneCtrlMgr = new e.CObjResMgr(0, () => new e.CSceneCtrlUID());
}
get ID() {
return this.m_nID;
}
set ID(e) {
this.m_nID = e;
}
get OnEnter() {
return this.m_onEnter;
}
get OnLeave() {
return this.m_onLeave;
}
get BehavTimerMgr() {
return this.m_oBehavTimerMgr;
}
_awake() {
this.m_oBehavTimerMgr = this.getComponent(e.CBehavTimerMgr);
this.m_oBehavTimerMgr.init(e.CSingleton(e.CBattleSceneFrameLoop));
}
begin() {
return this.m_oSceneCtrlMgr.begin();
}
end() {
return this.m_oSceneCtrlMgr.end();
}
rbegin() {
return this.m_oSceneCtrlMgr.rbegin();
}
rend() {
return this.m_oSceneCtrlMgr.rend();
}
get Size() {
return this.m_oSceneCtrlMgr.getSize();
}
get(e) {
let t = this.m_oSceneCtrlMgr.getObj(e);
return null == t ? null : t.BehavSceneCtrl;
}
add(e) {
let t = this.m_oSceneCtrlMgr.createObj(0);
t.BehavSceneCtrl = e;
e._setUID.call(e, t.UID);
this.m_onEnter.invoke(e);
}
remove(e) {
this.m_onLeave.invoke(e);
let t = e.UID;
e._setUID.call(e, null);
this.m_oSceneCtrlMgr.releaseObj(t);
}
kickOutAll() {
let e = [], t = this.m_oSceneCtrlMgr.end();
for (let r = this.m_oSceneCtrlMgr.begin(); r != t; ) {
let t = r.Data;
r = r.Next;
e.push(t.BehavSceneCtrl.leaveScene());
}
return Promise.all(e);
}
_destroy() {
this.kickOutAll();
}
};
})(Share || (Share = {}));

(function(e) {
e.CBehavSceneCtrl = class extends e.CUnitBehavior {
constructor(t) {
super(t);
this.m_onBeforeSwitchScene = new e.CDelegate();
this.m_onAfterSwitchScene = new e.CDelegate();
}
get OnBeforeSwitchScene() {
return this.m_onBeforeSwitchScene;
}
get OnAfterSwitchScene() {
return this.m_onAfterSwitchScene;
}
get Scene() {
return this.m_oCurScene;
}
get UID() {
return this.m_oUID;
}
_setUID(e) {
this.m_oUID = e;
}
enterScene(t) {
return t == this.m_oCurScene ? Promise.resolve(e.EErrorNo.Success) : Promise.resolve().then(() => {
let r = this.m_oCurScene;
this.m_onBeforeSwitchScene.invoke(this, r, t);
r && r.remove(this);
this.m_oCurScene = t;
t && t.add(this);
this.m_onAfterSwitchScene.invoke(this, r, t);
return e.EErrorNo.Success;
});
}
leaveScene() {
return this.enterScene(null);
}
_destroy() {
this.leaveScene();
}
};
})(Share || (Share = {}));

(function(e) {
e.CBehavTimerMgr = class extends e.CUnitBehavior {
constructor(e) {
super(e);
}
get TimerMgr() {
return this.m_oTimerMgr;
}
init(t, r = 0) {
this.m_oTimerMgr = e.CTimerMgr.create(t, r);
}
_destroy() {
e.CTimerMgr.release(this.m_oTimerMgr);
}
};
})(Share || (Share = {}));

(function(e) {
e.CFrameLoopTimerImpl = class {
constructor() {
this.onFrame = new e.CDelegate();
this.m_nLastMilliTimestamp = Date.now();
this._frameLoop();
}
_frameLoop() {
this.m_oTimer = setTimeout(() => {
let e = this.m_nLastMilliTimestamp;
this.m_nLastMilliTimestamp = Date.now();
this.onFrame.invoke(this.m_nLastMilliTimestamp - e);
this._frameLoop();
}, 1);
}
stop() {
if (this.m_oTimer) {
clearTimeout(this.m_oTimer);
this.m_oTimer = null;
}
}
};
})(Share || (Share = {}));

(function(e) {
e.CEffectAddProperty = class extends e.CEffect {
_getObjType() {
return e.EEffectType.AddProperty;
}
_onAdd(t, r) {
this.m_oBehavProperty = t.getComponent(e.CBehavProperty);
if (null != this.m_oBehavProperty) {
this.m_strPropertyField = r[0];
this.m_nPropertyValue = r[1];
this.m_oBehavProperty.add(e.EPropertyContainerType.Property, this.m_strPropertyField, this.m_nPropertyValue);
}
}
_onRemove() {
null != this.m_oBehavProperty && this.m_oBehavProperty.add(e.EPropertyContainerType.Property, this.m_strPropertyField, -this.m_nPropertyValue);
}
_isAddForever() {
return !1;
}
};
})(Share || (Share = {}));

(function(e) {
e.CSceneCtrlUID = class {
get UID() {
return this.m_oUID;
}
get BehavSceneCtrl() {
return this.m_oBehavSceneCtrl;
}
set BehavSceneCtrl(e) {
this.m_oBehavSceneCtrl = e;
}
qconstructor(e) {
this.m_oUID = e;
}
qdestructor() {
this.m_oUID = null;
}
getObjType() {
return 0;
}
};
})(Share || (Share = {}));

(function(e) {
let t;
(function(e) {
e[e.GuaJiNpc = 2] = "GuaJiNpc";
})(t = e.EAIType || (e.EAIType = {}));
})(Share || (Share = {}));

(function(e) {
let t;
(function(e) {
e[e.Booster1 = 1] = "Booster1";
e[e.Booster2 = 2] = "Booster2";
e[e.Booster3 = 3] = "Booster3";
})(t = e.EBoosterType || (e.EBoosterType = {}));
})(Share || (Share = {}));

(function(e) {
let t;
(function(e) {
e[e.AddProperty = 1] = "AddProperty";
})(t = e.EEffectType || (e.EEffectType = {}));
})(Share || (Share = {}));

(function(e) {
let t;
(function(e) {
e[e.Property = 0] = "Property";
e[e.VirtualProperty = 1] = "VirtualProperty";
e[e.ViewProperty = 2] = "ViewProperty";
})(t = e.EPropertyContainerType || (e.EPropertyContainerType = {}));
})(Share || (Share = {}));

(function(e) {
let t;
(function(e) {
e[e.Exp = 1] = "Exp";
e[e.Level = 2] = "Level";
e[e.Gem = 3] = "Gem";
e[e.Coin = 4] = "Coin";
e[e.OfflineSeconds = 5] = "OfflineSeconds";
e[e.InviteRewardCount = 6] = "InviteRewardCount";
e[e.InviteCount = 7] = "InviteCount";
e[e.Friends = 8] = "Friends";
e[e.FriendRequests = 9] = "FriendRequests";
e[e.FriendSocial = 10] = "FriendSocial";
e[e.Heart = 11] = "Heart";
e[e.HeartRecord = 12] = "HeartRecord";
e[e.CloudTime = 13] = "CloudTime";
e[e.Mail = 14] = "Mail";
})(t = e.EPropertyType || (e.EPropertyType = {}));
})(Share || (Share = {}));

(function(e) {
let t;
(function(e) {
e[e.cloudShare = 1] = "cloudShare";
e[e.inviteShare = 2] = "inviteShare";
e[e.tractorShare = 3] = "tractorShare";
e[e.farmerShare = 4] = "farmerShare";
e[e.otherShare = 5] = "otherShare";
e[e.offlineShare = 6] = "offlineShare";
e[e.payShare = 7] = "payShare";
e[e.rebBoxShare = 8] = "rebBoxShare";
e[e.pyqShare = 9] = "pyqShare";
e[e.xslbShare = 10] = "xslbShare";
e[e.leadShare = 11] = "leadShare";
e[e.CBTShare = 12] = "CBTShare";
e[e.TLShare = 13] = "TLShare";
e[e.EmpolyeeShare = 14] = "EmpolyeeShare";
e[e.openLand = 15] = "openLand";
e[e.upgradeGold = 16] = "upgradeGold";
e[e.xsflShare = 17] = "xsflShare";
e[e.OldUserShare = 18] = "OldUserShare";
e[e.orderShare = 19] = "orderShare";
e[e.DcrMoodShare = 20] = "DcrMoodShare";
e[e.Gopher = 21] = "Gopher";
e[e.newGuideAward = 22] = "newGuideAward";
e[e.cardBagYuanbaoShare = 23] = "cardBagYuanbaoShare";
e[e.cardBagTiliShare = 24] = "cardBagTiliShare";
e[e.repeatPieceShare = 25] = "repeatPieceShare";
e[e.zhuanpanPieceShare = 26] = "zhuanpanPieceShare";
e[e.shareAward = 27] = "shareAward";
})(t = e.EShareType || (e.EShareType = {}));
})(Share || (Share = {}));

(function(e) {
let t;
(function(e) {
e[e.PlayerAttack = 1] = "PlayerAttack";
e[e.Mercenary1Attack = 2] = "Mercenary1Attack";
e[e.Mercenary2Attack = 3] = "Mercenary2Attack";
e[e.Booster1 = 4] = "Booster1";
e[e.Booster2 = 5] = "Booster2";
e[e.Booster3 = 6] = "Booster3";
e[e.CastBooster1 = 7] = "CastBooster1";
})(t = e.ESkillType || (e.ESkillType = {}));
})(Share || (Share = {}));

(function(e) {
let t;
(function(e) {
e[e.Attack = 0] = "Attack";
})(t = e.EUnitMessageType || (e.EUnitMessageType = {}));
})(Share || (Share = {}));

(function(e) {
e.CPtcFriendRequestArg = class {
constructor() {
this.val = new e.CProtocolArg(e.EProtocolType.FriendRequest);
}
};
e.CPtcAddFriendArg = class {
constructor() {
this.val = new e.CProtocolArg(e.EProtocolType.AddFriend);
}
};
})(Share || (Share = {}));

(function(e) {
e.CConsoleLogPrinter = class {
_getTime() {
let e = new Date();
return "[" + e.getFullYear() + "/" + (e.getMonth() + 1) + "/" + e.getDate() + " " + e.getHours() + ":" + e.getMinutes() + ":" + e.getSeconds() + "]";
}
debug(...e) {
console.debug("[DEBUG]" + this._getTime(), ...e);
}
info(...e) {
console.info("[INFO]" + this._getTime(), ...e);
}
warn(...e) {
console.warn("[WARN]" + this._getTime(), ...e);
}
error(...e) {
console.error("[ERROR]" + this._getTime(), ...e);
}
};
})(Share || (Share = {}));

(function(e) {
class t {
constructor(e, r) {
this.add = function(e) {
let r = t.from(e);
var i = this.high_ >>> 16, s = 65535 & this.high_, o = this.low_ >>> 16, n = 65535 & this.low_, a = r.high_ >>> 16, h = 65535 & r.high_, l = r.low_ >>> 16, c = 0, m = 0, u = 0, g = 0;
u += (g += n + (65535 & r.low_)) >>> 16;
g &= 65535;
m += (u += o + l) >>> 16;
u &= 65535;
c += (m += s + h) >>> 16;
m &= 65535;
c += i + a;
c &= 65535;
return t.fromBits(u << 16 | g, c << 16 | m);
};
this.inc = function() {
return this.add(t.ONE);
};
this.dec = function() {
return this.add(t.NEG_ONE);
};
this.valueOf = function() {
return this.toNumber();
};
this.unaryPlus = function() {
return this;
};
this.unaryMinus = this.negate;
this.inv = this.not;
this.low_ = 0 | e;
this.high_ = 0 | r;
}
static fromInt(e) {
if (-128 <= e && e < 128) {
var r = t.IntCache_[e];
if (r) return r;
}
var i = new t(0 | e, e < 0 ? -1 : 0);
-128 <= e && e < 128 && (t.IntCache_[e] = i);
return i;
}
static fromNumber(e) {
return isNaN(e) || !isFinite(e) ? t.ZERO : e <= -t.TWO_PWR_63_DBL_ ? t.MIN_VALUE : e + 1 >= t.TWO_PWR_63_DBL_ ? t.MAX_VALUE : e < 0 ? t.fromNumber(-e).negate() : new t(e % t.TWO_PWR_32_DBL_ | 0, e / t.TWO_PWR_32_DBL_ | 0);
}
static fromBits(e, r) {
return new t(e, r);
}
static fromString(e, r) {
if (0 == e.length) throw Error("number format error: empty string");
var i = r || 10;
if (i < 2 || 36 < i) throw Error("radix out of range: " + i);
if ("-" == e.charAt(0)) return t.fromString(e.substring(1), i).negate();
if (e.indexOf("-") >= 0) throw Error('number format error: interior "-" character: ' + e);
for (var s = t.fromNumber(Math.pow(i, 8)), o = t.ZERO, n = 0; n < e.length; n += 8) {
var a = Math.min(8, e.length - n), h = parseInt(e.substring(n, n + a), i);
if (a < 8) {
var l = t.fromNumber(Math.pow(i, a));
o = o.multiply(l).add(t.fromNumber(h));
} else o = (o = o.multiply(s)).add(t.fromNumber(h));
}
return o;
}
toInt() {
return this.low_;
}
toNumber() {
return this.high_ * t.TWO_PWR_32_DBL_ + this.getLowBitsUnsigned();
}
hashCode() {
return this.high_ ^ this.low_;
}
toString(e) {
var r = e || 10;
if (r < 2 || 36 < r) throw Error("radix out of range: " + r);
if (this.isZero()) return "0";
if (this.isNegative()) {
if (this.equalsLong(t.MIN_VALUE)) {
var i = t.fromNumber(r), s = this.div(i);
let e = s.multiply(i).subtract(this);
return s.toString(r) + e.toInt().toString(r);
}
return "-" + this.negate().toString(r);
}
var o = t.fromNumber(Math.pow(r, 6));
let n = this;
for (var a = ""; ;) {
var h = n.div(o), l = n.subtract(h.multiply(o)).toInt().toString(r);
if ((n = h).isZero()) return l + a;
for (;l.length < 6; ) l = "0" + l;
a = "" + l + a;
}
}
getHighBits() {
return this.high_;
}
getLowBits() {
return this.low_;
}
getLowBitsUnsigned() {
return this.low_ >= 0 ? this.low_ : t.TWO_PWR_32_DBL_ + this.low_;
}
getNumBitsAbs() {
if (this.isNegative()) return this.equalsLong(t.MIN_VALUE) ? 64 : this.negate().getNumBitsAbs();
for (var e = 0 != this.high_ ? this.high_ : this.low_, r = 31; r > 0 && 0 == (e & 1 << r); r--) ;
return 0 != this.high_ ? r + 33 : r + 1;
}
isZero() {
return 0 == this.high_ && 0 == this.low_;
}
isNegative() {
return this.high_ < 0;
}
isOdd() {
return 1 == (1 & this.low_);
}
equalsLong(e) {
return this.high_ == e.high_ && this.low_ == e.low_;
}
notEqualsLong(e) {
return this.high_ != e.high_ || this.low_ != e.low_;
}
equals(e) {
return 0 === this.compare(e);
}
static from(e) {
let r = e;
return "number" === e ? t.fromNumber(r) : "string" === e ? t.fromString(r) : r;
}
lessThan(e) {
return this.compare(e) < 0;
}
lessThanOrEqual(e) {
return this.compare(e) <= 0;
}
greaterThan(e) {
return this.compare(e) > 0;
}
greaterThanOrEqual(e) {
return this.compare(e) >= 0;
}
compare(e) {
let r = t.from(e);
if (this.equalsLong(r)) return 0;
var i = this.isNegative(), s = r.isNegative();
return i && !s ? -1 : !i && s ? 1 : this.subtract(r).isNegative() ? -1 : 1;
}
negate() {
return this.equalsLong(t.MIN_VALUE) ? t.MIN_VALUE : this.not().add(t.ONE);
}
subtract(e) {
return this.add(t.from(e).negate());
}
multiply(e) {
let r = t.from(e);
if (this.isZero()) return t.ZERO;
if (r.isZero()) return t.ZERO;
if (this.equalsLong(t.MIN_VALUE)) return r.isOdd() ? t.MIN_VALUE : t.ZERO;
if (r.equalsLong(t.MIN_VALUE)) return this.isOdd() ? t.MIN_VALUE : t.ZERO;
if (this.isNegative()) return r.isNegative() ? this.negate().multiply(r.negate()) : this.negate().multiply(r).negate();
if (r.isNegative()) return this.multiply(r.negate()).negate();
if (this.lessThan(t.TWO_PWR_24_) && r.lessThan(t.TWO_PWR_24_)) return t.fromNumber(this.toNumber() * r.toNumber());
var i = this.high_ >>> 16, s = 65535 & this.high_, o = this.low_ >>> 16, n = 65535 & this.low_, a = r.high_ >>> 16, h = 65535 & r.high_, l = r.low_ >>> 16, c = 65535 & r.low_, m = 0, u = 0, g = 0, _ = 0;
g += (_ += n * c) >>> 16;
_ &= 65535;
u += (g += o * c) >>> 16;
g &= 65535;
u += (g += n * l) >>> 16;
g &= 65535;
m += (u += s * c) >>> 16;
u &= 65535;
m += (u += o * l) >>> 16;
u &= 65535;
m += (u += n * h) >>> 16;
u &= 65535;
m += i * c + s * l + o * h + n * a;
m &= 65535;
return t.fromBits(g << 16 | _, m << 16 | u);
}
div(e) {
let r = t.from(e);
if (r.isZero()) throw Error("division by zero");
if (this.isZero()) return t.ZERO;
if (this.equalsLong(t.MIN_VALUE)) {
if (r.equalsLong(t.ONE) || r.equalsLong(t.NEG_ONE)) return t.MIN_VALUE;
if (r.equalsLong(t.MIN_VALUE)) return t.ONE;
var i = this.shiftRight(1).div(r).shiftLeft(1);
if (i.equalsLong(t.ZERO)) return r.isNegative() ? t.ONE : t.NEG_ONE;
{
let e = this.subtract(r.multiply(i));
return i.add(e.div(r));
}
}
if (r.equalsLong(t.MIN_VALUE)) return t.ZERO;
if (this.isNegative()) return r.isNegative() ? this.negate().div(r.negate()) : this.negate().div(r).negate();
if (r.isNegative()) return this.div(r.negate()).negate();
var s = t.ZERO;
let o = this;
for (;o.greaterThanOrEqual(r); ) {
for (var n = Math.max(1, Math.floor(o.toNumber() / r.toNumber())), a = Math.ceil(Math.log(n) / Math.LN2), h = a <= 48 ? 1 : Math.pow(2, a - 48), l = t.fromNumber(n), c = l.multiply(r); c.isNegative() || c.greaterThan(o); ) {
n -= h;
c = (l = t.fromNumber(n)).multiply(r);
}
l.isZero() && (l = t.ONE);
s = s.add(l);
o = o.subtract(c);
}
return s;
}
modulo(e) {
let r = t.from(e);
return this.subtract(this.div(r).multiply(r));
}
not() {
return t.fromBits(~this.low_, ~this.high_);
}
and(e) {
let r = t.from(e);
return t.fromBits(this.low_ & r.low_, this.high_ & r.high_);
}
or(e) {
let r = t.from(e);
return t.fromBits(this.low_ | r.low_, this.high_ | r.high_);
}
xor(e) {
let r = t.from(e);
return t.fromBits(this.low_ ^ r.low_, this.high_ ^ r.high_);
}
shiftLeft(e) {
if (0 == (e &= 63)) return this;
var r = this.low_;
if (e < 32) {
var i = this.high_;
return t.fromBits(r << e, i << e | r >>> 32 - e);
}
return t.fromBits(0, r << e - 32);
}
shiftRight(e) {
if (0 == (e &= 63)) return this;
var r = this.high_;
if (e < 32) {
var i = this.low_;
return t.fromBits(i >>> e | r << 32 - e, r >> e);
}
return t.fromBits(r >> e - 32, r >= 0 ? 0 : -1);
}
shiftRightUnsigned(e) {
if (0 == (e &= 63)) return this;
var r = this.high_;
if (e < 32) {
var i = this.low_;
return t.fromBits(i >>> e | r << 32 - e, r >>> e);
}
return 32 == e ? t.fromBits(r, 0) : t.fromBits(r >>> e - 32, 0);
}
}
t.IntCache_ = {};
t.TWO_PWR_16_DBL_ = 65536;
t.TWO_PWR_24_DBL_ = 1 << 24;
t.TWO_PWR_32_DBL_ = t.TWO_PWR_16_DBL_ * t.TWO_PWR_16_DBL_;
t.TWO_PWR_31_DBL_ = t.TWO_PWR_32_DBL_ / 2;
t.TWO_PWR_48_DBL_ = t.TWO_PWR_32_DBL_ * t.TWO_PWR_16_DBL_;
t.TWO_PWR_64_DBL_ = t.TWO_PWR_32_DBL_ * t.TWO_PWR_32_DBL_;
t.TWO_PWR_63_DBL_ = t.TWO_PWR_64_DBL_ / 2;
t.ZERO = t.fromInt(0);
t.ONE = t.fromInt(1);
t.NEG_ONE = t.fromInt(-1);
t.MAX_VALUE = t.fromBits(-1, 2147483647);
t.MIN_VALUE = t.fromBits(0, -2147483648);
t.TWO_PWR_24_ = t.fromInt(1 << 24);
e.CInt64 = t;
})(Share || (Share = {}));

(function(e) {
e.CPtcKickoutArg = class {
constructor() {
this.val = new e.CProtocolArg(e.EProtocolType.Kickout);
}
};
})(Share || (Share = {}));

(function(e) {
e.CPtcSyncPropertyArg = class {
constructor() {
this.val = new e.CProtocolArg(e.EProtocolType.SyncProperty);
}
};
})(Share || (Share = {}));

(function(e) {
e.CBuyArg = class {
constructor() {
this.val = new e.CProtocolArg(e.EProtocolType.Buy);
}
};
})(Share || (Share = {}));

(function(e) {
e.CClaimInviteRewardArg = class {
constructor() {
this.val = new e.CProtocolArg(e.EProtocolType.ClaimInviteReward);
}
};
})(Share || (Share = {}));

(function(e) {
e.CClaimOfflineRewardArg = class {
constructor() {
this.val = new e.CProtocolArg(e.EProtocolType.ClaimOfflineReward);
}
};
})(Share || (Share = {}));

(function(e) {
e.CCreatePlayerArg = class {
constructor() {
this.val = new e.CProtocolArg(e.EProtocolType.CreatePlayer);
}
};
})(Share || (Share = {}));

(function(e) {
e.CEnterWorldArg = class {
constructor() {
this.val = new e.CProtocolArg(e.EProtocolType.EnterWorld);
}
};
let t;
(function(e) {
e[e.DaLi = 0] = "DaLi";
e[e.DaoLuan = 1] = "DaoLuan";
})(t = e.ERecordType || (e.ERecordType = {}));
})(Share || (Share = {}));

(function(e) {
e.CFinishGuaJiArg = class {
constructor() {
this.val = new e.CProtocolArg(e.EProtocolType.FinishGuaJi);
}
};
})(Share || (Share = {}));

(function(e) {
e.CFriendRequestArg = class {
constructor() {
this.val = new e.CProtocolArg(e.EProtocolType.FriendRequest);
}
};
e.CAddFriendArg = class {
constructor() {
this.val = new e.CProtocolArg(e.EProtocolType.AddFriend);
}
};
e.CIgnoreFriendRequestArg = class {
constructor() {
this.val = new e.CProtocolArg(e.EProtocolType.IgnoreFriendRequest);
}
};
e.CDaLiArg = class {
constructor() {
this.val = new e.CProtocolArg(e.EProtocolType.DaLi);
}
};
e.CDaoLuanArg = class {
constructor() {
this.val = new e.CProtocolArg(e.EProtocolType.DaoLuan);
}
};
e.CFireArg = class {
constructor() {
this.val = new e.CProtocolArg(e.EProtocolType.Fire);
}
};
e.CModifyMailArg = class {
constructor() {
this.val = new e.CProtocolArg(e.EProtocolType.ModifyMail);
}
};
})(Share || (Share = {}));

(function(e) {
e.CGetAccessTokenArg = class {
constructor() {
this.val = new e.CProtocolArg(e.EProtocolType.GetAccessToken);
}
};
})(Share || (Share = {}));

(function(e) {
e.CGetInviteesArg = class {
constructor() {
this.val = new e.CProtocolArg(e.EProtocolType.GetInvitees);
}
};
})(Share || (Share = {}));

(function(e) {
e.CGetInviteesByShareTypeArg = class {
constructor() {
this.val = new e.CProtocolArg(e.EProtocolType.GetInviteesByShareType);
}
};
})(Share || (Share = {}));

(function(e) {
e.CGetRandomUserArg = class {
constructor() {
this.val = new e.CProtocolArg(e.EProtocolType.GetRandomUser);
}
};
})(Share || (Share = {}));

(function(e) {
e.CGetTickArg = class {
constructor() {
this.val = new e.CProtocolArg(e.EProtocolType.GetTick);
}
};
})(Share || (Share = {}));

(function(e) {
e.CGetWXACodeUnlimitArg = class {
constructor() {
this.val = new e.CProtocolArg(e.EProtocolType.GetWXACodeUnlimit);
}
};
})(Share || (Share = {}));

(function(e) {
e.CGotoMarketArg = class {
constructor() {
this.val = new e.CProtocolArg(e.EProtocolType.GotoMarket);
}
};
})(Share || (Share = {}));

(function(e) {
e.CLeaveWorldArg = class {
constructor() {
this.val = new e.CProtocolArg(e.EProtocolType.LeaveWorld);
}
};
})(Share || (Share = {}));

(function(e) {
e.CLoginArg = class {
constructor() {
this.val = new e.CProtocolArg(e.EProtocolType.Login);
}
};
})(Share || (Share = {}));

(function(e) {
e.CLogoutArg = class {
constructor() {
this.val = new e.CProtocolArg(e.EProtocolType.Logout);
}
};
})(Share || (Share = {}));

(function(e) {
e.COpenTractorArg = class {
constructor() {
this.val = new e.CProtocolArg(e.EProtocolType.OpenTractor);
}
};
})(Share || (Share = {}));

(function(e) {
e.CQueryPlayerArg = class {
constructor() {
this.val = new e.CProtocolArg(e.EProtocolType.QueryPlayer);
}
};
})(Share || (Share = {}));

(function(e) {
e.CQueryUserDataArg = class {
constructor() {
this.val = new e.CProtocolArg(e.EProtocolType.QueryUserData);
}
};
})(Share || (Share = {}));

(function(e) {
e.CRebornArg = class {
constructor() {
this.val = new e.CProtocolArg(e.EProtocolType.Reborn);
}
};
})(Share || (Share = {}));

(function(e) {
e.CReLoginArg = class {
constructor() {
this.val = new e.CProtocolArg(e.EProtocolType.ReLogin);
}
};
})(Share || (Share = {}));

(function(e) {
e.CSavePlayerArg = class {
constructor() {
this.val = new e.CProtocolArg(e.EProtocolType.SavePlayer);
}
};
})(Share || (Share = {}));

(function(e) {
e.CSaveUserDataArg = class {
constructor() {
this.val = new e.CProtocolArg(e.EProtocolType.SaveUserData);
}
};
})(Share || (Share = {}));

(function(e) {
e.CStartRainArg = class {
constructor() {
this.val = new e.CProtocolArg(e.EProtocolType.StartRain);
}
};
})(Share || (Share = {}));

(function(e) {
e.CUpgradePropertyArg = class {
constructor() {
this.val = new e.CProtocolArg(e.EProtocolType.UpgradeProperty);
}
};
})(Share || (Share = {}));

(function(e) {
e.CUseBoosterArg = class {
constructor() {
this.val = new e.CProtocolArg(e.EProtocolType.UseBooster);
}
};
})(Share || (Share = {}));

(function(e) {
e.CWxLoginArg = class {
constructor() {
this.val = new e.CProtocolArg(e.EProtocolType.WxLogin);
}
};
})(Share || (Share = {}));

(function(e) {
class t {
constructor(e) {
this.owner = e;
}
getPrev() {
return this.prev;
}
getNext() {
return this.next;
}
}
e.CLinkedListNode = t;
e.CLinkedList = class {
constructor() {
this.head = new t(this);
this.tail = new t(this);
this.m_nCount = 0;
this.head.prev = null;
this.head.next = this.tail;
this.tail.prev = this.head;
this.tail.next = null;
}
begin() {
return this.head.getNext();
}
end() {
return this.tail;
}
rbegin() {
return this.tail.getPrev();
}
rend() {
return this.begin;
}
clear() {
this.m_nCount = 0;
this.head.prev = null;
this.head.next = this.tail;
this.tail.prev = this.head;
this.tail.next = null;
}
insertBefore(e, r) {
if (e.owner !== this) return null;
if (e === this.head) return null;
let i = e.prev, s = new t(this);
s.data = r;
s.next = e;
s.prev = i;
e.prev = s;
i.next = s;
++this.m_nCount;
return s;
}
insertAfter(e, r) {
if (e.owner !== this) return null;
if (e === this.tail) return null;
let i = e.next, s = new t(this);
s.data = r;
s.next = i;
s.prev = e;
e.next = s;
i.prev = s;
++this.m_nCount;
return s;
}
remove(e) {
if (e.owner !== this) return !1;
if (e === this.tail || e === this.head) return !1;
let t = e.prev, r = e.next;
e.prev = null;
e.next = null;
e.owner = null;
t.next = r;
r.prev = t;
--this.m_nCount;
return !0;
}
removeRange(e, t) {
if (e.owner !== this || t.owner !== this) return !1;
if (e === this.tail || e === this.head || t === this.head || t === this.head.getNext()) return !1;
if (e === t) return !0;
let r = e.prev, i = t, s = 0;
for (let t = e; t != i; t = t.getNext()) if (null == t || t === this.tail) return !1;
for (let t = e; t != i; t = t.getNext()) ++s;
r.next = i;
i.prev = r;
this.m_nCount -= s;
return !0;
}
count() {
return this.m_nCount;
}
};
})(Share || (Share = {}));

(function(e) {
e.CProtocolArg = class {
constructor(e) {
this.type = e;
this.data = {};
}
};
class t {
qconstructor(e) {
this.m_oUId = e;
}
qdestructor() {
if (this.m_oSendTimeout) {
clearTimeout(this.m_oSendTimeout);
this.m_oSendTimeout = null;
}
this.m_oCallback = null;
this.m_oUId = null;
}
getObjType() {
return 0;
}
getUID() {
return this.m_oUId;
}
}
e.CRpcSendTask = t;
e.CRpcTaskMgr = class {
constructor() {
this.m_oMgr = new e.CObjResMgr(1e3, e => new t());
}
createRpcTask() {
return this.m_oMgr.createObj(0);
}
releaseRpcTask(e) {
this.m_oMgr.releaseObj(e);
}
releaseAllRpcTask() {
this.m_oMgr.releaseAll();
}
getRpcTask(e) {
return this.m_oMgr.getObj(e);
}
};
})(Share || (Share = {}));

(function(e) {
e.CSession = class {
constructor(t, r) {
this.m_nToRecvLen = 0;
this.m_strRecvData = "";
this.m_oSendReceiver = null;
this.m_onError = null;
this.m_onClose = null;
this.m_onUnBind = null;
this.m_oRpcTaskMgr = new e.CRpcTaskMgr();
this.m_strRemoteIp = "";
this.m_oSendReceiver = t;
this.m_onUnBind = r;
this.m_strRemoteIp = t.getRemoteIp();
if (this.m_oSendReceiver) {
this.m_oSendReceiver.onRecv(e => {
this._onRecv(e);
});
this.m_oSendReceiver.onError(e => {
this.m_onError && this.m_onError(e);
});
}
}
getUserData() {
return this.m_oUserData;
}
setUserData(e) {
this.m_oUserData = e;
}
_onRecv(t) {
if ("string" != typeof t) return this.close();
let r = t.toString();
if (r && r.length) if (0 == this.m_nToRecvLen) {
let e = 0;
for (;e != r.length && "{" != r[e]; ++e) ;
if (e == r.length) this.m_strRecvData += r; else {
this.m_strRecvData += r.substr(0, e);
let t = Number(this.m_strRecvData);
if (isNaN(t)) return this.close();
this.m_nToRecvLen = t;
this.m_strRecvData = "";
this._onRecv(r.substr(e));
}
} else {
if (this.m_nToRecvLen >= 10485760) return this.close();
if (this.m_strRecvData.length + r.length >= this.m_nToRecvLen) {
let t = this.m_nToRecvLen - this.m_strRecvData.length;
this.m_strRecvData += r.substr(0, t);
let i = null;
try {
i = JSON.parse(this.m_strRecvData);
} catch (e) {
return this.close();
}
if (void 0 == i.type || !i.data) return this.close();
this.m_strRecvData = "";
this.m_nToRecvLen = 0;
if (i.uid) if (i.isReply) {
let t = new e.CObjResUID(i.uid.m_nIndex, i.uid.m_nCheckNum), r = this.m_oRpcTaskMgr.getRpcTask(t);
if (r) {
let e = r.m_oCallback;
this.m_oRpcTaskMgr.releaseRpcTask(t);
e(null, i.data);
}
} else {
let t = e.CSingleton(e.CProtocolMgr).getController(i.type);
t && t.onCall && Promise.resolve(t.onCall(i.data, this)).then(e => {
if (null == this.m_oSendReceiver) return;
let t = {
uid: i.uid,
isReply: !0,
type: i.type,
data: e
};
try {
let e = JSON.stringify(t);
this.m_oSendReceiver.send(e.length + e);
} catch (e) {}
});
} else {
let t = e.CSingleton(e.CProtocolMgr).getController(i.type);
t && t.onProcess && t.onProcess(i.data, this);
}
this._onRecv(r.substr(t));
} else this.m_strRecvData += r;
}
}
unbindCallback(e) {
this.m_onUnBind = e;
}
unbind() {
this.m_nToRecvLen = 0;
this.m_strRecvData = "";
let e = this.m_oSendReceiver;
if (this.m_oSendReceiver) {
this.m_oSendReceiver.onRecv(null);
this.m_oSendReceiver.onError(null);
}
this.m_oSendReceiver = null;
let t = this.m_onUnBind;
t && e && setTimeout(() => {
t(e);
}, 0);
}
getRemoteIp() {
return this.m_strRemoteIp;
}
isClosed() {
return null == this.m_oSendReceiver;
}
close() {
if (this.isClosed()) return;
let e = this.m_onClose, t = this.m_oSendReceiver;
this.unbind();
if (null != t) {
e && setTimeout(() => {
e();
}, 0);
this.m_oSendReceiver = null;
}
}
callRpc(t, r = 3e4) {
if (this.isClosed()) return Promise.reject(new Error("send on a closed session"));
let i = r;
if (i <= 0) return Promise.reject(e.CSingleton(e.CErrorMsgHelper).errorMsg(e.EErrorNo.Timeout));
let s = this.m_oRpcTaskMgr.createRpcTask(), o = s.getUID(), n = e.CPromiseHelper.createPromise();
s.m_oCallback = n.callback;
s.m_oSendTimeout = setTimeout(() => {
this.m_oRpcTaskMgr.releaseRpcTask(o);
n.callback(e.CSingleton(e.CErrorMsgHelper).errorMsg(e.EErrorNo.Timeout));
}, i);
let a = JSON.stringify({
type: t.type,
uid: o,
data: t.data
});
this.m_oSendReceiver.send(a.length + a);
return n.promise;
}
sendPtc(e) {
if (this.isClosed()) return;
let t = JSON.stringify({
type: e.type,
data: e.data
});
this.m_oSendReceiver.send(t.length + t);
}
onError(e) {
this.m_onError = e;
}
onClose(e) {
this.m_onClose = e;
}
};
})(Share || (Share = {}));

(function(e) {
let t;
(function(e) {
e[e.none = -1] = "none";
e[e.debug = 0] = "debug";
e[e.info = 1] = "info";
e[e.warn = 2] = "warn";
e[e.error = 3] = "error";
})(t = e.ELogLevel || (e.ELogLevel = {}));
e.CLogHelper = class {
static registerPrinter(e, ...r) {
if (null != e) {
null != r && 0 != r.length || (r = [ t.debug, t.info, t.warn, t.error ]);
for (let t = 0; t != r.length; ++t) this._registerPrinter(e, r[t]);
}
}
static _registerPrinter(e, r) {
if (null != e && null != r && r != t.none) {
null == this.m_oLogPrinter && (this.m_oLogPrinter = []);
null == this.m_oLogPrinter[r] && (this.m_oLogPrinter[r] = []);
this.m_oLogPrinter[r].push(e);
}
}
static debug(...e) {
if (null == this.m_oLogPrinter) return;
let r = this.m_oLogPrinter[t.debug];
if (null != r) for (let t = 0; t != r.length; ++t) r[t].debug(...e);
}
static info(...e) {
if (null == this.m_oLogPrinter) return;
let r = this.m_oLogPrinter[t.debug];
if (null != r) for (let t = 0; t != r.length; ++t) r[t].info(...e);
}
static warn(...e) {
if (null == this.m_oLogPrinter) return;
let r = this.m_oLogPrinter[t.debug];
if (null != r) for (let t = 0; t != r.length; ++t) r[t].warn(...e);
}
static error(...e) {
if (null == this.m_oLogPrinter) return;
let r = this.m_oLogPrinter[t.debug];
if (null != r) for (let t = 0; t != r.length; ++t) r[t].error(...e);
}
};
})(Share || (Share = {}));

(function(e) {
e.CBehavClientCore = class extends Share.CUnitBehavior {
constructor(e) {
super(e);
}
get UseHttps() {
return this.m_bUseHttps;
}
get GameServer() {
return this.m_strGameServer;
}
get HttpServer() {
return this.m_strHttpServer;
}
_awake() {}
Init() {
return Promise.resolve(!0);
}
Load(e) {
this.m_bUseHttps = e.useHttps;
this.m_strGameServer = (this.m_bUseHttps ? "wss:" : "ws:") + e.gameServer;
this.m_strHttpServer = (this.m_bUseHttps ? "https:" : "http:") + e.httpServer;
Share.CSingleton(Share.CGlobalConfigMgr).init(e.clientTable.m_oGlobalConfigMgr);
Share.CSingleton(Share.CShareSwitchMgr).init(e.clientTable.m_oShareSwitchMgr);
Share.CSingleton(Share.CFarmLandAttrMgr).init(e.clientTable.m_oFramLandAttrMgr);
Share.CSingleton(Share.CCropAttrMgr).init(e.clientTable.m_oCropAttrMgr);
Share.CSingleton(Share.CUnitAttrMgr).init(e.clientTable.m_oUnitAttrMgr);
Share.CSingleton(Share.CTechAttrMgr).init(e.clientTable.m_oTechAttrMgr);
Share.CSingleton(Share.CInviteAttrMgr).init(e.clientTable.m_oInviteAttrMgr);
Share.CSingleton(Share.CFarmSkinAttrMgr).init(e.clientTable.m_oFarmSkinAttrMgr);
Share.CSingleton(Share.CFarmAttrMgr).init(e.clientTable.m_oFarmAttrMgr);
Share.CSingleton(Share.CGemItemAttrMgr).init(e.clientTable.m_oGemItemAttrMgr);
Share.CSingleton(Share.CUnlockAttrMgr).init(e.clientTable.m_oUnlockAttrMgr);
Share.CSingleton(Share.CWheelAttrMgr).init(e.clientTable.m_oWheelAttrMgr);
Share.CSingleton(Share.CSevenDaysAttrMgr).init(e.clientTable.m_oSevenDaysAttrMgr);
Share.CSingleton(Share.CInviteClientAttrMgr).init(e.clientTable.m_oInviteClintAttrMgr);
Share.CSingleton(Share.CAutoRewardAttrMgr).init(e.clientTable.m_oAutoRewardAttrMgr);
Share.CSingleton(Share.CJobAttrMgr).init(e.clientTable.m_oJobAttrMgr);
Share.CSingleton(Share.CFarmerAttrMgr).init(e.clientTable.m_oFarmerAttrMgr);
Share.CSingleton(Share.CGuideTaskAttrMgr).init(e.clientTable.m_oGuideTaskAttrMgr);
Share.CSingleton(Share.CDialogueAttrMgr).init(e.clientTable.m_oDialogueAttrMgr);
Share.CSingleton(Share.CTreasureFirstAttrMgr).init(e.clientTable.m_oTreasureFirstAttrMgr);
Share.CSingleton(Share.CTreasureSecondAttrMgr).init(e.clientTable.m_oTreasureSecondAttrMgr);
Share.CSingleton(Share.CBubbleFirstAttrMgr).init(e.clientTable.m_oBubbleFirstAttrMgr);
Share.CSingleton(Share.CBubbleSecondAttrMgr).init(e.clientTable.m_oBubbleSecondAttrMgr);
Share.CSingleton(Share.CProvinceAttrMgr).init(e.clientTable.m_oProvinceAttrMgr);
return Promise.resolve(!0);
}
CreateAccountSession() {
return new e.CUnitClientSession(this).BehavInterface;
}
DestroyClientSession(e) {
e.destroy();
}
};
})(ClientCore || (ClientCore = {}));

(function(e) {
e.CUnitClientCore = class extends Share.CUnit {
constructor() {
super(Share.CUBC(e.CBehavClientCore));
this.m_oClientCore = this.getComponent(e.CBehavClientCore);
}
get ClientCore() {
return this.m_oClientCore;
}
};
})(ClientCore || (ClientCore = {}));

if ("undefined" != typeof window) {
window.Share = Share;
window.ClientCore = ClientCore;
}

(function(e) {
e.CWSConnector = class {
static connect(t) {
let r;
try {
r = new WebSocket(t);
} catch (e) {
return Promise.reject(e);
}
r.binaryType = "arraybuffer";
let i = Share.CPromiseHelper.createPromise();
r.onopen = (() => {
i.callback(null, new e.CWSSendReceiver(r, t));
r.onerror = null;
});
r.onerror = (e => {
i.callback(e.data);
});
return i.promise;
}
};
})(ClientCore || (ClientCore = {}));

(function(e) {
e.CWSSendReceiver = class {
constructor(e, t) {
this.m_oWebSocket = e;
this.m_strRemoteUrl = t;
e.onmessage = (e => {
this.m_onRecv && this.m_onRecv(e.data);
});
e.onerror = (e => {
this.m_onError && this.m_onError(e.data);
});
e.onclose = (e => {
this.m_onClose && this.m_onClose();
});
}
isClosed() {
return null == this.m_oWebSocket;
}
close() {
if (!this.isClosed() && this.m_oWebSocket) {
this.m_oWebSocket.close();
this.m_oWebSocket = null;
}
}
send(e) {
this.m_oWebSocket.send(e);
return Promise.resolve();
}
onRecv(e) {
this.m_onRecv = e;
}
onError(e) {
this.m_onError = e;
}
onClose(e) {
this.m_onClose = e;
}
getRemoteIp() {
return this.m_strRemoteUrl;
}
};
})(ClientCore || (ClientCore = {}));

(function(e) {
Share.CSingleton(Share.CProtocolMgr).registerController(class {
static onProcess(e, t) {
let r = t.getUserData();
null == r || r.isDestroyed() || r.onFriendRequest(e);
}
}, Share.EProtocolType.FriendRequest);
Share.CSingleton(Share.CProtocolMgr).registerController(class {
static onProcess(e, t) {
let r = t.getUserData();
null == r || r.isDestroyed() || r.onFriendRequest(e);
}
}, Share.EProtocolType.AddFriend);
})(ClientCore || (ClientCore = {}));

(function(e) {
Share.CSingleton(Share.CProtocolMgr).registerController(class {
static onProcess(e, t) {
let r = t.getUserData();
null == r || r.isDestroyed() || r.onInvite(e);
}
}, Share.EProtocolType.Invite);
})(ClientCore || (ClientCore = {}));

(function(e) {
Share.CSingleton(Share.CProtocolMgr).registerController(class {
static onProcess(e, t) {
let r = t.getUserData();
null == r || r.isDestroyed() || r.beKickout();
}
}, Share.EProtocolType.Kickout);
})(ClientCore || (ClientCore = {}));

(function(e) {
Share.CSingleton(Share.CProtocolMgr).registerController(class {
static onProcess(e, t) {
let r = t.getUserData();
null == r || r.isDestroyed() || r.BehavAccount && r.BehavAccount.BehavPlayer && r.BehavAccount.BehavPlayer.BeSyncProperty(e.name, e.value);
}
}, Share.EProtocolType.SyncProperty);
})(ClientCore || (ClientCore = {}));

(function(e) {
e.CBehavSceneInterface = class extends Share.CUnitBehavior {
constructor(e) {
super(e);
}
get OnEnter() {
return this.m_oBehavScene.OnEnter;
}
get OnLeave() {
return this.m_oBehavScene.OnLeave;
}
_awake() {
this.m_oBehavScene = this.getComponent(Share.CBehavScene);
}
};
})(ClientCore || (ClientCore = {}));

(function(e) {
e.CUnitScene = class extends Share.CUnit {
constructor() {
super(Share.CUBC(Share.CBehavTimerMgr), [ Share.CUBC(Share.CBehavScene), Share.CUBC(e.CBehavSceneInterface) ]);
this.m_oBehavScene = this.getComponent(Share.CBehavScene);
}
get BehavScene() {
return this.m_oBehavScene;
}
};
})(ClientCore || (ClientCore = {}));

(function(e) {
e.CBehavAccount = class extends Share.CUnitBehavior {
constructor(e) {
super(e);
}
_awake() {
this.m_oBehavSession = this.getComponent(e.CBehavSession);
this.m_oBehavPlayer = this.getComponent(e.CBehavPlayer);
}
get BehavPlayer() {
return this.m_oBehavPlayer;
}
get BehavSession() {
return this.m_oBehavSession;
}
get AccountInfo() {
return this.m_oAccountInfo;
}
setAccountInfo(e) {
this.m_oAccountInfo = e;
}
getPlayerBriefInfo(e) {
return this.m_oAccountInfo.playerUIDs[e];
}
};
})(ClientCore || (ClientCore = {}));

(function(e) {
e.CBehavClientSessionInterface = class extends Share.CUnitBehavior {
constructor(e) {
super(e);
this.m_onGemChanged = new Share.CDelegate();
this.m_onCoinChanged = new Share.CDelegate();
this.m_onLevelChanged = new Share.CDelegate();
this.m_onExpChanged = new Share.CDelegate();
}
_awake() {
this.m_oBehavSession = this.getComponent(e.CBehavSession);
this.m_oBehavPlayer = this.getComponent(e.CBehavPlayer);
this.m_oBehavAccount = this.getComponent(e.CBehavAccount);
this.m_oBehavPlayerList = this.getComponent(e.CBehavPlayerList);
this.m_oBehavWorldGate = this.getComponent(e.CBehavWorldGate);
this.m_oBehavSceneCtrl = this.getComponent(Share.CBehavSceneCtrl);
this.m_oBehavProperty = this.getComponent(Share.CBehavProperty);
this.m_oBehavReborn = this.getComponent(e.CBehavReborn);
this.m_oBehavUpgrade = this.getComponent(e.CBehavUpgrade);
this.m_oBehavShop = this.getComponent(e.CBehavShop);
this.m_oBehavPropertyCalc = this.getComponent(Share.CBehavPropertyCalc);
this.m_oBehavOffline = this.getComponent(e.CBehavOffline);
this.m_oBehavFriend = this.getComponent(e.CBehavFriend);
this.m_oBehavMail = this.getComponent(e.CBehavMail);
this.m_oBehavProperty.OnPropertyChanged.add((e, t, r, i) => {
if (e === Share.EPropertyContainerType.Property) switch (t) {
case Share.EPropertyType[Share.EPropertyType.Gem]:
this.m_onGemChanged.invoke(r, i);
break;

case Share.EPropertyType[Share.EPropertyType.Coin]:
this.m_onCoinChanged.invoke(r, i);
break;

case Share.EPropertyType[Share.EPropertyType.Level]:
this.m_onLevelChanged.invoke(r, i);
break;

case Share.EPropertyType[Share.EPropertyType.Exp]:
this.m_onExpChanged.invoke(r, i);
}
});
}
get BehavSession() {
return this.m_oBehavSession;
}
get BehavPropertyCalc() {
return this.m_oBehavPropertyCalc;
}
get BehavProperty() {
return this.m_oBehavProperty;
}
get OnGemChanged() {
return this.m_onGemChanged;
}
get OnCoinChanged() {
return this.m_onCoinChanged;
}
get OnLevelChanged() {
return this.m_onLevelChanged;
}
get OnExpChanged() {
return this.m_onExpChanged;
}
get AccountInfo() {
return this.m_oBehavAccount.AccountInfo;
}
get PlayerInfo() {
return this.m_oBehavPlayer.PlayerInfo;
}
get Scene() {
return this.m_oBehavSceneCtrl.Scene;
}
get OnBeforeSwitchScene() {
return this.m_oBehavSceneCtrl.OnBeforeSwitchScene;
}
get OnAfterSwitchScene() {
return this.m_oBehavSceneCtrl.OnAfterSwitchScene;
}
get HasMercenary2() {
return this.m_oBehavPlayer.PlayerInfo.Mercenary2EndTimestamp > Date.now() / 1e3 >>> 0;
}
wxLogin(e) {
let t = new Share.CWxLoginArg();
t.val.data = {
code: e
};
return this.m_oBehavSession.callRpc(t.val);
}
login(e) {
return this.m_oBehavSession.login(e);
}
logout() {
return this.m_oBehavSession.logout();
}
setGuaJiTimescale(e) {
this.m_oBehavSceneCtrl.Scene.BehavTimerMgr.TimerMgr.TimeScale = e;
}
createPlayer(e) {
return this.m_oBehavPlayerList.createPlayer(e);
}
enterWorld(e, t, r = "", i = -1) {
return this.m_oBehavWorldGate.enterWorld(e, t, r, i);
}
leaveWorld() {
return this.m_oBehavWorldGate.leaveWorld();
}
save(e) {
return this.m_oBehavPlayer.save(e);
}
saveUserData(e) {
return this.m_oBehavPlayer.saveUserData(e);
}
startRain() {
return this.m_oBehavPlayer.startRain();
}
openTractor() {
return this.m_oBehavPlayer.openTractor();
}
gotoMarket() {
return this.m_oBehavPlayer.gotoMarket();
}
reborn() {
return this.m_oBehavReborn.reborn();
}
upgradeProperty(e, t = 1) {
return this.m_oBehavUpgrade.upgradeProperty(e, t);
}
buy(e, t, r = 1) {
return this.m_oBehavShop.buy(e, t, r);
}
claimOfflineReward(e) {
return this.m_oBehavOffline.claim(e);
}
getOfflineReward() {
return this.m_oBehavOffline.getOfflineReward();
}
claimInviteReward(e) {
return this.m_oBehavFriend.claimInviteReward(e);
}
getInvitees() {
return this.m_oBehavFriend.getInvitees();
}
getInviteesByShareType(e, t, r) {
return this.m_oBehavFriend.getInviteesByShareType(e, t, r);
}
reqAddFriend(e) {
return this.m_oBehavFriend.reqAddFriend(e);
}
addFriend(e) {
return this.m_oBehavFriend.addFriend(e);
}
ignoreFriendRequest(e) {
return this.m_oBehavFriend.ignoreFriendRequest(e);
}
dali(e) {
return this.m_oBehavFriend.dali(e);
}
daoluan(e) {
return this.m_oBehavFriend.daoluan(e);
}
fire(e) {
return this.m_oBehavFriend.fire(e);
}
modifyMail(e, t) {
return this.m_oBehavMail.modifyMail(e, t);
}
queryPlayer(e) {
let t = new Share.CQueryPlayerArg();
t.val.data = {
accountName: e
};
return this.m_oBehavSession.callRpc(t.val);
}
queryUserData(e) {
let t = new Share.CQueryUserDataArg();
t.val.data = {
ActName: e
};
return this.m_oBehavSession.callRpc(t.val);
}
getRandomUser() {
let e = new Share.CGetRandomUserArg();
return this.m_oBehavSession.callRpc(e.val);
}
getTick() {
let e = new Share.CGetTickArg();
return this.m_oBehavSession.callRpc(e.val);
}
};
})(ClientCore || (ClientCore = {}));

(function(e) {
e.CBehavFriend = class extends Share.CUnitBehavior {
constructor(e) {
super(e);
}
_awake() {
this.m_oBehavSession = this.getComponent(e.CBehavSession);
}
getInvitees() {
let e = new Share.CGetInviteesArg();
return this.m_oBehavSession.callRpc(e.val);
}
getInviteesByShareType(e, t, r) {
let i = new Share.CGetInviteesByShareTypeArg();
i.val.data = {
shareType: e,
startTime: t,
endTime: r
};
return this.m_oBehavSession.callRpc(i.val);
}
claimInviteReward(e) {
let t = new Share.CClaimInviteRewardArg();
t.val.data = {
inviteAttrId: e
};
return this.m_oBehavSession.callRpc(t.val).then(e => e.errno == Share.EErrorNo.Success ? Promise.reject(null) : Promise.reject(e)).catch(e => null == e ? Share.CSingleton(Share.CErrorMsgHelper).successMsg({}) : Share.CSingleton(Share.CErrorMsgHelper).toErrorMsg(e));
}
reqAddFriend(e) {
let t = new Share.CFriendRequestArg();
t.val.data = {
playerAct: e
};
return this.m_oBehavSession.callRpc(t.val);
}
addFriend(e) {
let t = new Share.CAddFriendArg();
t.val.data = {
playerAct: e
};
return this.m_oBehavSession.callRpc(t.val);
}
ignoreFriendRequest(e) {
let t = new Share.CIgnoreFriendRequestArg();
t.val.data = {
playerAct: e
};
return this.m_oBehavSession.callRpc(t.val);
}
dali(e) {
let t = new Share.CDaLiArg();
t.val.data = {
playerAct: e
};
return this.m_oBehavSession.callRpc(t.val);
}
daoluan(e) {
let t = new Share.CDaoLuanArg();
t.val.data = {
playerAct: e
};
return this.m_oBehavSession.callRpc(t.val);
}
fire(e) {
let t = new Share.CFireArg();
t.val.data = {
playerAct: e
};
return this.m_oBehavSession.callRpc(t.val);
}
};
})(ClientCore || (ClientCore = {}));

(function(e) {
e.CBehavMail = class extends Share.CUnitBehavior {
constructor(e) {
super(e);
}
_awake() {
this.m_oBehavSession = this.getComponent(e.CBehavSession);
}
modifyMail(e, t) {
let r = new Share.CModifyMailArg();
r.val.data = {
id: e,
status: t
};
return this.m_oBehavSession.callRpc(r.val);
}
};
})(ClientCore || (ClientCore = {}));

(function(e) {
e.CBehavOffline = class extends Share.CUnitBehavior {
constructor(e) {
super(e);
}
_awake() {
this.m_oBehavSession = this.getComponent(e.CBehavSession);
this.m_oBehavProperty = this.getComponent(Share.CBehavProperty);
this.m_oBehavPropertyCalc = this.getComponent(Share.CBehavPropertyCalc);
}
claim(e) {
let t = new Share.CProtocolArg(Share.EProtocolType.ClaimOfflineReward);
t.data = {
bDouble: e
};
return this.m_oBehavSession.callRpc(t).then(e => e.errno == Share.EErrorNo.Success ? Promise.reject(null) : Promise.reject(e)).catch(e => null == e ? Share.CSingleton(Share.CErrorMsgHelper).successMsg({}) : Share.CSingleton(Share.CErrorMsgHelper).toErrorMsg(e));
}
getOfflineReward() {
let e = this.m_oBehavProperty.get(Share.EPropertyContainerType.Property, Share.EPropertyType[Share.EPropertyType.OfflineSeconds]);
return this.m_oBehavPropertyCalc.getOfflineCoinPerSecond() * e;
}
};
})(ClientCore || (ClientCore = {}));

(function(e) {
e.CBehavPlayer = class extends Share.CUnitBehavior {
constructor(e) {
super(e);
this.m_nDeltaGuaJiExtExp = 0;
}
_awake() {
this.m_oBehavSession = this.getComponent(e.CBehavSession);
this.m_oBehavProperty = this.getComponent(Share.CBehavProperty);
this.m_oBehavProperty.register(Share.EPropertyContainerType.VirtualProperty, {});
this.m_oBehavProperty.register(Share.EPropertyContainerType.ViewProperty, {});
this.m_oBehavPropertyCalc = this.getComponent(Share.CBehavPropertyCalc);
}
_onGuaJiExtExpChanged(e, t) {
let r = t - e;
this._syncDeltaGuaJiExtExp(r);
}
_syncDeltaGuaJiExtExp(e) {}
get BehavSession() {
return this.m_oBehavSession;
}
get PlayerInfo() {
return this.m_oPlayerInfo;
}
BeSyncProperty(e, t) {
this.m_oBehavProperty.set(Share.EPropertyContainerType.Property, e, t);
}
setPlayerInfo(e) {
this.m_oPlayerInfo = e;
this.m_oBehavProperty.register(Share.EPropertyContainerType.Property, e);
}
_destroy() {
this.m_oSyncGuaJiExtExpTimer && clearTimeout(this.m_oSyncGuaJiExtExpTimer);
}
save(e) {
let t = new Share.CProtocolArg(Share.EProtocolType.SavePlayer);
t.data = {
coin: e.Coin,
gem: e.Gem,
notificationLastShowTime: e.NotificationLastShowTime,
userData: e.UserData,
statistics: e.Statistics
};
return this.m_oBehavSession.callRpc(t).then(e => Share.CSingleton(Share.CErrorMsgHelper).toErrorMsg(null)).catch(e => Share.CSingleton(Share.CErrorMsgHelper).toErrorMsg(e));
}
saveUserData(e) {
let t = new Share.CProtocolArg(Share.EProtocolType.SaveUserData);
t.data = {
nickName: e.Name,
avatar: e.Avatar,
customData: e.CustomData
};
return this.m_oBehavSession.callRpc(t).then(e => Share.CSingleton(Share.CErrorMsgHelper).toErrorMsg(null)).catch(e => Share.CSingleton(Share.CErrorMsgHelper).toErrorMsg(e));
}
startRain() {
let e = new Share.CProtocolArg(Share.EProtocolType.StartRain);
return this.m_oBehavSession.callRpc(e).then(e => Share.CSingleton(Share.CErrorMsgHelper).toErrorMsg(e)).catch(e => Share.CSingleton(Share.CErrorMsgHelper).toErrorMsg(e));
}
openTractor() {
let e = new Share.CProtocolArg(Share.EProtocolType.OpenTractor);
return this.m_oBehavSession.callRpc(e).then(e => Share.CSingleton(Share.CErrorMsgHelper).toErrorMsg(e)).catch(e => Share.CSingleton(Share.CErrorMsgHelper).toErrorMsg(e));
}
gotoMarket() {
let e = new Share.CProtocolArg(Share.EProtocolType.GotoMarket);
return this.m_oBehavSession.callRpc(e).then(e => Share.CSingleton(Share.CErrorMsgHelper).toErrorMsg(e)).catch(e => Share.CSingleton(Share.CErrorMsgHelper).toErrorMsg(e));
}
};
})(ClientCore || (ClientCore = {}));

(function(e) {
e.CBehavPlayerAttacker = class extends Share.CUnitBehavior {
constructor(e) {
super(e);
}
};
})(ClientCore || (ClientCore = {}));

(function(e) {
e.CBehavPlayerList = class extends Share.CUnitBehavior {
constructor(e) {
super(e);
}
_awake() {
this.m_oBehavSession = this.getComponent(e.CBehavSession);
this.m_oBehavAccount = this.getComponent(e.CBehavAccount);
}
get BehavSession() {
return this.m_oBehavSession;
}
getPlayerList() {
return null == this.m_oBehavAccount.AccountInfo ? null : this.m_oBehavAccount.AccountInfo.playerUIDs;
}
getPlayerCount() {
if (null == this.m_oBehavAccount.AccountInfo || null == this.m_oBehavAccount.AccountInfo.playerUIDs) return 0;
let e = 0, t = this.m_oBehavAccount.AccountInfo.playerUIDs;
for (let r = 0; r != t.length; ++r) t[r] && e++;
return e;
}
createPlayer(e) {
let t = new Share.CProtocolArg(Share.EProtocolType.CreatePlayer);
t.data = {
playerName: e
};
return this.m_oBehavSession.callRpc(t).then(e => {
e.errno == Share.EErrorNo.Success && (this.m_oBehavAccount.AccountInfo.playerUIDs[e.ext.index] = e.ext.playerUID);
return Promise.reject(e);
}).catch(e => Share.CSingleton(Share.CErrorMsgHelper).toErrorMsg(e));
}
};
})(ClientCore || (ClientCore = {}));

(function(e) {
e.CBehavReborn = class extends Share.CUnitBehavior {
constructor(e) {
super(e);
}
_awake() {
this.m_oBehavSession = this.getComponent(e.CBehavSession);
}
reborn() {
let e = new Share.CProtocolArg(Share.EProtocolType.Reborn);
e.data = {};
return this.m_oBehavSession.callRpc(e).then(e => e.errno == Share.EErrorNo.Success ? Promise.reject(null) : Promise.reject(e)).catch(e => null == e ? Share.CSingleton(Share.CErrorMsgHelper).successMsg({}) : Share.CSingleton(Share.CErrorMsgHelper).toErrorMsg(e));
}
};
})(ClientCore || (ClientCore = {}));

(function(e) {
e.CBehavSession = class extends Share.CUnitBehavior {
constructor(e, t) {
super(e);
this.m_onClosed = new Share.CAsyncDelegate();
this.m_onRelogin = new Share.CDelegate();
this.m_onKickout = new Share.CAsyncDelegate();
this.m_onInvite = new Share.CDelegate();
this.m_onFriendRequest = new Share.CDelegate();
this.m_onFriendResponse = new Share.CDelegate();
this.m_bKickouted = !1;
this.m_inAreas = !1;
this.m_oClientCore = t;
this.m_strUrl = t.GameServer;
}
get OnRelogin() {
return this.m_onRelogin;
}
get SessionUID() {
return this.m_oSessionUID;
}
get SessionToken() {
return this.m_strSessionToken;
}
get InAreas() {
return this.m_inAreas;
}
_awake() {
this.m_oBehavAccount = this.getComponent(e.CBehavAccount);
}
get BehavAccount() {
return this.m_oBehavAccount;
}
get ClientCore() {
return this.m_oClientCore;
}
get OnClosed() {
return this.m_onClosed;
}
get OnInvite() {
return this.m_onInvite;
}
get OnFriendRequest() {
return this.m_onFriendRequest;
}
get OnFriendResponse() {
return this.m_onFriendResponse;
}
_destroy() {
null != this.m_oSession && this.m_oSession.close();
}
_reconnect(e) {
return e <= 0 ? Promise.resolve(Share.EErrorNo.Fail) : this._connect().then(t => t == Share.EErrorNo.Success ? Promise.reject(null) : 1 == e ? Promise.reject(t) : Share.CPromiseHelper.delay(1e3).then(() => this._reconnect(--e))).catch(e => null == e ? Share.EErrorNo.Success : e);
}
_connect() {
if (null == this.m_strUrl || "" === this.m_strUrl) return Promise.resolve(Share.EErrorNo.InvalidArguments);
if (!this.isClosed()) return Promise.resolve(Share.EErrorNo.Connected);
let t;
return e.CWSConnector.connect(this.m_strUrl).then(e => {
if (null == (t = e)) return Promise.reject(new Error("connect failed"));
if (this.isDisabled()) {
t.close();
return Promise.reject(new Error("Behavior Disabled"));
}
let r = new Share.CSession(t, e => {
e.close();
});
t.onClose(() => {
r.close();
});
if (this.isDisabled()) {
r.close();
return Promise.reject(new Error("Behavior Disabled"));
}
this.m_bToClose = !1;
r.setUserData(this);
r.onClose(() => {
this.close();
r.setUserData(null);
Share.CLogHelper.info("session closed");
});
this.m_oSession = r;
return Share.EErrorNo.Success;
}).catch(e => {
Share.CLogHelper.warn(e);
return Share.EErrorNo.Fail;
});
}
get isLogined() {
return !this.isClosed() && null != this.m_oSessionUID;
}
close() {
if (null != this.m_oSession) {
this.m_oSession.close();
this.m_oSession = null;
}
this.m_oSessionUID = null;
this.m_bToClose = !0;
if (this.m_oPingTimer) {
clearTimeout(this.m_oPingTimer);
this.m_oPingTimer = null;
}
}
isClosed() {
return null == this.m_oSession || this.m_oSession.isClosed();
}
_restartPing() {
if (!this.isClosed()) {
this.m_oPingTimer && clearTimeout(this.m_oPingTimer);
this.m_oSession.sendPtc(new Share.CProtocolArg(Share.EProtocolType.Ping));
this.m_oPingTimer = setTimeout(() => {
this._restartPing();
}, 3e4);
}
}
_login() {
if (!this.m_strAccountName) return Promise.resolve(Share.CSingleton(Share.CErrorMsgHelper).errorMsg(Share.EErrorNo.InvalidArguments));
if (this.m_oSession.isClosed()) return Promise.resolve(Share.CSingleton(Share.CErrorMsgHelper).errorMsg(Share.EErrorNo.SessionClosed));
if (this.isLogined) return Promise.resolve(Share.CSingleton(Share.CErrorMsgHelper).errorMsg(Share.EErrorNo.InvalidOperation));
let e = new Share.CLoginArg();
e.val.data = {
accountName: this.m_strAccountName,
sign: this.m_strSign,
channelToken: this.m_strChannelToken
};
return this.m_oSession.callRpc(e.val).then(e => {
if (0 != e.errno) return Promise.reject(Share.CSingleton(Share.CErrorMsgHelper).toErrorMsg(e));
this.m_strSessionToken = e.ext.sessionToken;
this.m_oSessionUID = e.ext.sessionUID;
this.m_oBehavAccount.setAccountInfo(e.ext.accoutInfo);
this.m_oLastLoginSessionUID = this.m_oSessionUID;
this.m_inAreas = e.ext.inAreas;
return Promise.reject(Share.CSingleton(Share.CErrorMsgHelper).successMsg(this.m_oBehavAccount));
}).catch(e => {
0 != e.errno && e.errno != Share.EErrorNo.TryAgain && this.m_oSession.close();
0 == e.errno ? this._restartPing() : this.m_oSessionUID = null;
return e;
});
}
login(e) {
this.m_bKickouted = !1;
this.m_strAccountName = e.accountName;
this.m_strSign = e.sign;
this.m_strChannelToken = e.channelToken;
let t = Promise.resolve(Share.EErrorNo.Success);
this.isClosed() && (t = this._reconnect(10));
return t.then(e => e != Share.EErrorNo.Success ? Share.CSingleton(Share.CErrorMsgHelper).errorMsg(e) : this._login());
}
logout() {
if (!this.isLogined) return Promise.resolve(Share.CSingleton(Share.CErrorMsgHelper).errorMsg(Share.EErrorNo.Fail));
let e = new Share.CLogoutArg();
e.val.data.accountName = this.m_oBehavAccount.AccountInfo.accountName;
return this.m_oSession.callRpc(e.val).then(e => {
0 == e.errno && this.m_oSession.close();
return Promise.reject(null);
}).catch(e => {
if (null == e) {
this.m_oSessionUID = null;
return Share.CSingleton(Share.CErrorMsgHelper).successMsg();
}
return Share.CSingleton(Share.CErrorMsgHelper).toErrorMsg(e);
});
}
beKickout() {
this.m_bKickouted = !0;
Share.CLogHelper.warn("be kickout");
this.m_onKickout.invoke();
this.m_oSession && this.m_oSession.close();
}
_reLogin(e = !1) {
if (this.m_bKickouted) return Promise.resolve(Share.CSingleton(Share.CErrorMsgHelper).errorMsg(Share.EErrorNo.Fail));
if (this.isLogined) return Promise.resolve(Share.CSingleton(Share.CErrorMsgHelper).successMsg());
if (e) return this.login({
accountName: this.m_strAccountName,
sign: this.m_strSign,
channelToken: this.m_strChannelToken
}).then(e => 0 == e.errno ? Promise.all(this.m_onRelogin.invoke()).then(e => {
if (null == e) return Share.CSingleton(Share.CErrorMsgHelper).successMsg();
for (let t = 0; t != e.length; ++t) if (0 != e[t].errno) return e[t];
return Share.CSingleton(Share.CErrorMsgHelper).successMsg();
}) : e.errno == Share.EErrorNo.TryAgain ? Share.CPromiseHelper.delay(500).then(() => this._reLogin(!0)) : e);
let t = Promise.resolve(Share.EErrorNo.Success);
this.isClosed() && (t = this._reconnect(10));
return t.then(e => {
if (e != Share.EErrorNo.Success) return Promise.reject(Share.CSingleton(Share.CErrorMsgHelper).errorMsg(e));
let t = new Share.CReLoginArg();
t.val.data = {
accountName: this.m_strAccountName,
sessionUID: this.m_oLastLoginSessionUID,
sessionToken: this.m_strSessionToken
};
return this.m_oSession.callRpc(t.val);
}).then(e => 0 == e.errno ? Promise.reject(null) : this._reLogin(!0)).then(e => 0 == e.errno ? Promise.reject(null) : Promise.reject(e)).catch(e => null == e ? Share.CSingleton(Share.CErrorMsgHelper).successMsg() : Share.CSingleton(Share.CErrorMsgHelper).toErrorMsg(e));
}
onInvite(e) {
this.m_onInvite.invoke(e);
}
onFriendRequest(e) {
this.m_onFriendRequest.invoke(e);
}
onFriendResponse(e) {
this.m_onFriendResponse.invoke(e);
}
callRpc(e, t = 2e4) {
return this.isLogined || e.type == Share.EProtocolType.ReLogin || e.type == Share.EProtocolType.Login ? this.m_oSession.callRpc(e, t) : this._reLogin().then(r => {
if (0 != r.errno) {
this.OnClosed.invoke();
return Promise.reject(new Error("send on a closed session"));
}
return this.m_oSession.callRpc(e, t);
});
}
sendPtc(e) {
if (this.isLogined || e.type == Share.EProtocolType.ReLogin || e.type == Share.EProtocolType.Login) return this.m_oSession.sendPtc(e);
this._reLogin().then(t => {
if (0 == t.errno) return this.m_oSession.sendPtc(e);
this.OnClosed.invoke();
});
}
};
})(ClientCore || (ClientCore = {}));

(function(e) {
e.CBehavShop = class extends Share.CUnitBehavior {
constructor(e) {
super(e);
}
_awake() {
this.m_oBehavSession = this.getComponent(e.CBehavSession);
}
buy(e, t, r = 1) {
let i = new Share.CProtocolArg(Share.EProtocolType.Buy);
i.data = {
shopID: e,
goodsID: t,
count: r
};
return this.m_oBehavSession.callRpc(i).then(e => e.errno == Share.EErrorNo.Success ? Promise.reject(null) : Promise.reject(e)).catch(e => null == e ? Share.CSingleton(Share.CErrorMsgHelper).successMsg({}) : Share.CSingleton(Share.CErrorMsgHelper).toErrorMsg(e));
}
};
})(ClientCore || (ClientCore = {}));

(function(e) {
e.CBehavUpgrade = class extends Share.CUnitBehavior {
constructor(e) {
super(e);
}
_awake() {
this.m_oBehavSession = this.getComponent(e.CBehavSession);
}
upgradeProperty(e, t = 1) {
let r = new Share.CProtocolArg(Share.EProtocolType.UpgradeProperty);
r.data = {
propertyID: e,
times: t
};
return this.m_oBehavSession.callRpc(r).then(e => e.errno == Share.EErrorNo.Success ? Promise.reject(null) : Promise.reject(e)).catch(e => null == e ? Share.CSingleton(Share.CErrorMsgHelper).successMsg({}) : Share.CSingleton(Share.CErrorMsgHelper).toErrorMsg(e));
}
};
})(ClientCore || (ClientCore = {}));

(function(e) {
e.CBehavVirtualProperty = class extends Share.CUnitBehavior {};
})(ClientCore || (ClientCore = {}));

(function(e) {
e.CBehavWorldGate = class extends Share.CUnitBehavior {
constructor(e) {
super(e);
}
_awake() {
this.m_oBehavAccount = this.getComponent(e.CBehavAccount);
this.m_oBehavPlayer = this.getComponent(e.CBehavPlayer);
this.m_oBehavSession = this.getComponent(e.CBehavSession);
this.m_oBehavSceneCtrl = this.getComponent(Share.CBehavSceneCtrl);
this.m_oBehavSession.OnRelogin.add(this._onRelogin, this);
}
_onRelogin() {
return null == this.m_oBehavPlayer.PlayerInfo || null == this.m_nEnterWorldPlayerIndex ? Promise.resolve(Share.CSingleton(Share.CErrorMsgHelper).successMsg()) : this.enterWorld(this.m_nEnterWorldPlayerIndex);
}
enterWorld(t, r = "", i = "", s = -1) {
let o, n = new Share.CProtocolArg(Share.EProtocolType.EnterWorld);
n.data = {
playerIndex: t,
inviterUID: r,
inviterAct: i,
shareType: s
};
return this.m_oBehavSession.callRpc(n).then(r => {
if (0 != r.errno) return Promise.reject(r);
this.m_nEnterWorldPlayerIndex = t;
this.m_oBehavPlayer.setPlayerInfo(r.ext);
(o = new e.CUnitScene()).BehavScene.ID = 1;
return this.m_oBehavSceneCtrl.enterScene(o.BehavScene);
}).then(e => {
if (e != Share.EErrorNo.Success) {
o.destroy();
return Promise.reject(Share.CSingleton(Share.CErrorMsgHelper).createErrorMsg(e, ""));
}
return Promise.reject(null);
}).catch(e => Share.CSingleton(Share.CErrorMsgHelper).toErrorMsg(e));
}
leaveWorld() {
let e = new Share.CProtocolArg(Share.EProtocolType.LeaveWorld);
e.data = {
accountName: this.m_oBehavAccount.AccountInfo.accountName,
sessionUID: this.m_oBehavSession.SessionUID,
sessionToken: this.m_oBehavSession.SessionToken
};
return this.m_oBehavSession.callRpc(e).then(e => {
if (0 == e.errno) {
let e = this.m_oBehavSceneCtrl.Scene;
e && this.m_oBehavSceneCtrl.leaveScene().then(() => {
e.destroy();
});
this.m_nEnterWorldPlayerIndex = null;
this.m_oBehavPlayer.setPlayerInfo(null);
}
return Promise.reject(e);
}).catch(e => Share.CSingleton(Share.CErrorMsgHelper).toErrorMsg(e));
}
};
})(ClientCore || (ClientCore = {}));

(function(e) {
e.CPtcInviteArg = class {
constructor() {
this.val = new e.CProtocolArg(e.EProtocolType.Invite);
}
};
})(Share || (Share = {}));