var csv = {
__ID__: "ID",
__ROWS__: "values",
__SIZE__: "size",
__PS_INDEX__: 0,
__TYPE_INDEX__: 1,
__HEADER_INDEX__: 2,
__DATA_INDEX__: 3,
_StructData: function() {
this.header = [];
this.body = [];
},
_Row: function(e, t, r) {
var s = this;
this.index = r;
let c = [], a = [];
e.forEach(function(e, t) {
var [r, s] = e.split(":");
if (s) {
var n = s.match(/\[(\w*)\]/);
s = n ? "" == n[1] || "number" == n[1] ? "array.number" : "array.default" : "default";
} else s = "default";
a.push(r);
c.push(s);
});
a.forEach(function(e, r) {
var a = t[r], n = c[r];
if (n.startsWith("array")) if (a && a.length > 0) {
a = a.split(/[,\+&;\/\s]/);
n.endsWith("number") && (a = a.map(function(e) {
return Number(e);
}));
} else a = []; else if ("json" == n) a = JSON.parse(a); else {
var i = a.match(/\"(.*)\"/);
if (i) a = i[1] || a; else {
var o = Number(a);
isNaN(o) || (a = o);
}
}
Object.defineProperty(s, e, {
value: a,
writable: !1
});
});
}
};

csv._Row.prototype.match = function(e) {
return !(!e || !e(this, this.index));
};

csv._CSV = function(e) {
this._data = e;
this._rows = {};
var t = this;
let r = e.header.indexOf(csv.__ID__);
e.body.forEach(function(s, c) {
var a = new csv._Row(e.header, s, c);
delete e.body[c];
t._rows[s[r]] = a;
});
e.body.splice(0);
Object.defineProperty(this, csv.__ROWS__, {
get: function() {
return Object.values(t._rows);
}
});
Object.defineProperty(this, csv.__SIZE__, {
value: e.body.length,
writable: !1
});
};

csv._CSV.prototype.get = function(e) {
return this._rows[e];
};

csv._CSV.prototype.search = function(e) {
let t = [];
for (var r in this._rows) {
var s = this._rows[r];
s.match(e) && t.push(s);
}
return t;
};

csv.pathToCSV = {};

csv.isLoaded = function(e) {
return null != csv.pathToCSV[e];
};

csv.load = function(e, t, r) {
cc.loader.loadRes(e, cc.TextAsset, function(s, c) {
if (!csv.pathToCSV[c.name]) {
var a = csv.parse(c.text);
csv.pathToCSV[c.name] = a;
Object.defineProperty(csv, c.name, {
value: a,
writable: !1
});
}
cc.loader.releaseRes(e, cc.TextAsset);
t && t.call(r);
});
};

csv.loadString = function(e, t, r, s) {
if (!csv.pathToCSV[e]) {
var c = csv.parse(t);
csv.pathToCSV[e] = c;
Object.defineProperty(csv, e, {
value: c,
writable: !1
});
}
r && r.call(s);
};

csv.parse = function(e) {
var t = e.split("\n").filter(function(e) {
return "" != e;
}), r = new csv._StructData();
r.header = t[csv.__HEADER_INDEX__].replace(/[\r]/g, "").split(/\s*\t/g);
r.body = t.slice(csv.__DATA_INDEX__).map(function(e) {
return csv.parseRowWithT(e.replace(/\r/g, ""));
});
return new csv._CSV(r);
};

csv.parseRowWithT = function(e) {
return e.split("\t");
};

csv.parseRow = function(e) {
if (-1 === e.indexOf('"')) return e.split(",");
for (var t = "", r = [], s = !1, c = 0; c < e.length; c++) {
var a = e.charAt(c);
if ('"' !== a) if ("," !== a || s) t += a; else {
r.push(t);
t = "";
} else s = !s;
}
r.push(t);
return r;
};

csv.cache_indexKeyToTable = {};

csv.hasIndex = function(e) {
return null != csv.cache_indexKeyToTable[e];
};

csv.createIndex = function(e, t, r) {
if (!csv.hasIndex(e + "." + t)) {
var s = this[e];
s.values.forEach(function(e) {
var c = e[t];
if ("" != c && 0 != c) {
c = c.replace(/\s*/g, "");
Object.defineProperty(s, c, {
value: e[r],
writable: !1
});
}
});
csv.cache_indexKeyToTable[e + "." + t] = s;
}
};

csv.loadDir = function(e, t, r) {
cc.loader.loadResDir(e, cc.TextAsset, function(s, c, a) {
a.forEach(function(e, t) {
var r = c[t];
if (!csv.pathToCSV[e]) {
var s = csv.parse(r.text);
csv.pathToCSV[e] = s;
Object.defineProperty(csv, r.name, {
value: s,
writable: !1
});
}
});
cc.loader.releaseResDir(e, cc.TextAsset);
return t && t.call(r);
});
};

csv.release = function(e) {};

window.csv = csv;